﻿--- <settings>
---         <validatingquery>
---                if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_DatabaseVersion]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
---                begin
---                        declare @ver int
---                        exec @ver=sp_DatabaseVersion
---                        if (@ver >= 6100)
---                                select 0, 'Already correct database version'
---                        else if (@ver = 6005)
---                                select 1, 'Upgrading database'
---                        else
---                                select -1, 'Invalid database version detected'
---                end
---                else
---                        select -1, 'Not an EPiServer database'
---                </validatingquery>
--- </settings>
SET NUMERIC_ROUNDABORT OFF
GO
SET ANSI_PADDING, ANSI_WARNINGS, CONCAT_NULL_YIELDS_NULL, ARITHABORT, QUOTED_IDENTIFIER, ANSI_NULLS ON
GO
IF EXISTS (SELECT * FROM tempdb..sysobjects WHERE id=OBJECT_ID('tempdb..#tmpErrors')) DROP TABLE #tmpErrors
GO
CREATE TABLE #tmpErrors (Error int)
GO
SET XACT_ABORT ON
GO
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
GO
BEGIN TRANSACTION
GO
PRINT N'Dropping constraints from [dbo].[tblScheduledItem]'
GO

-- Special handling of th IsRunning constraint since it's been added without any name specified in CMS6

DECLARE @constraintName VARCHAR(50)
SELECT @constraintName = c.name FROM sys.objects AS t
INNER JOIN sys.objects AS c
ON t.object_id=c.parent_object_id
WHERE t.name='tblScheduledItem' AND c.type='D' AND c.name LIKE '%IsRun%'

EXEC ('ALTER TABLE [dbo].[tblScheduledItem] DROP CONSTRAINT ['+@constraintName+']')

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP
CONSTRAINT [FK_tblWorkPage_tblPage],
CONSTRAINT [FK_tblWorkPage_tblPage1],
CONSTRAINT [FK_tblWorkPage_tblPage2],
CONSTRAINT [FK_tblWorkPage_tblWorkPage2],
CONSTRAINT [FK_tblWorkPage_tblFrame],
CONSTRAINT [FK_tblWorkPage_tblLanguageBranch]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblCategoryPage]'
GO
ALTER TABLE [dbo].[tblCategoryPage] DROP
CONSTRAINT [FK_tblCategoryPage_tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblPageLanguageSetting]'
GO
ALTER TABLE [dbo].[tblPageLanguageSetting] DROP
CONSTRAINT [FK_tblPageLanguageSetting_tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblWorkCategory]'
GO
ALTER TABLE [dbo].[tblWorkCategory] DROP
CONSTRAINT [FK_tblWorkCategory_tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblProperty]'
GO
ALTER TABLE [dbo].[tblProperty] DROP
CONSTRAINT [FK_tblProperty_tblPage],
CONSTRAINT [FK_tblProperty_tblPage2]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblAccess]'
GO
ALTER TABLE [dbo].[tblAccess] DROP
CONSTRAINT [FK_tblAccess_tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP
CONSTRAINT [FK_tblPage_tblPage],
CONSTRAINT [FK_tblPage_tblPage1],
CONSTRAINT [FK_tblPage_tblPageType],
CONSTRAINT [FK_tblPage_tblLanguageBranch]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblWorkProperty]'
GO
ALTER TABLE [dbo].[tblWorkProperty] DROP
CONSTRAINT [FK_tblWorkProperty_tblPage],
CONSTRAINT [FK_tblWorkProperty_tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP
CONSTRAINT [FK_tblPageLanguage_tblPage1],
CONSTRAINT [FK_tblPageLanguage_tblPage2],
CONSTRAINT [FK_tblPageLanguage_tblLanguageBranch],
CONSTRAINT [FK_tblPageLanguage_tblFrame]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping foreign keys from [dbo].[tblPageSoftlink]'
GO
ALTER TABLE [dbo].[tblPageSoftlink] DROP
CONSTRAINT [FK_tblPageSoftlink_tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [PK_tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__PageGUID]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__Visible__2E06CDA9]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__Deleted__2EFAF1E2]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__Pending__31D75E8D]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__ChildOr__35A7EF71]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__PeerOrd__369C13AA]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] DROP CONSTRAINT [DF__tblPage__fkMasterLangaugeBranchID]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [PK_tblPageLanguage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__PageGUID]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__Automatic]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__FetchData]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__PendingPublish]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__Created]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__Changed]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] DROP CONSTRAINT [DF__tblPageLanguage__Saved]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [PK_tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__LinkT__48BAC3E5]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__Creat__49AEE81E]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__Saved__4AA30C57]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__Child__4B973090]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__PeerO__4C8B54C9]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__Ready__4D7F7902]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__Chang__4E739D3B]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__HasBe__4F67C174]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__Rejec__505BE5AD]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa_Delayed]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping constraints from [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] DROP CONSTRAINT [DF__tblWorkPa__fkLan__4258C320]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPage_fkPageTypeID] from [dbo].[tblPage]'
GO
DROP INDEX [IDX_tblPage_fkPageTypeID] ON [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPage_fkParentID] from [dbo].[tblPage]'
GO
DROP INDEX [IDX_tblPage_fkParentID] ON [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPage_fkArchivePageID] from [dbo].[tblPage]'
GO
DROP INDEX [IDX_tblPage_fkArchivePageID] ON [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPage_PageGUID] from [dbo].[tblPage]'
GO
DROP INDEX [IDX_tblPage_PageGUID] ON [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPage_ExternalFolderID] from [dbo].[tblPage]'
GO
DROP INDEX [IDX_tblPage_ExternalFolderID] ON [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPage_PagePath] from [dbo].[tblPage]'
GO
DROP INDEX [IDX_tblPage_PagePath] ON [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPageLanguage_fkPageLinkID] from [dbo].[tblPageLanguage]'
GO
DROP INDEX [IDX_tblPageLanguage_fkPageLinkID] ON [dbo].[tblPageLanguage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPageLanguage_Name] from [dbo].[tblPageLanguage]'
GO
DROP INDEX [IDX_tblPageLanguage_Name] ON [dbo].[tblPageLanguage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblPageLanguage_ExternalURL] from [dbo].[tblPageLanguage]'
GO
DROP INDEX [IDX_tblPageLanguage_ExternalURL] ON [dbo].[tblPageLanguage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblWorkPage_fkPageID] from [dbo].[tblWorkPage]'
GO
DROP INDEX [IDX_tblWorkPage_fkPageID] ON [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblWorkPage_fkMasterVersionID] from [dbo].[tblWorkPage]'
GO
DROP INDEX [IDX_tblWorkPage_fkMasterVersionID] ON [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblWorkPage_fkPageLinkID] from [dbo].[tblWorkPage]'
GO
DROP INDEX [IDX_tblWorkPage_fkPageLinkID] ON [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblWorkPage_fkArchivePageID] from [dbo].[tblWorkPage]'
GO
DROP INDEX [IDX_tblWorkPage_fkArchivePageID] ON [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblWorkPage_ChangedByName] from [dbo].[tblWorkPage]'
GO
DROP INDEX [IDX_tblWorkPage_ChangedByName] ON [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping index [IDX_tblWorkPage_StatusFields] from [dbo].[tblWorkPage]'
GO
DROP INDEX [IDX_tblWorkPage_StatusFields] ON [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Dropping [dbo].[netCreatePathForChildren]'
GO
DROP PROCEDURE [dbo].[netCreatePathForChildren]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Rebuilding [dbo].[tblPageLanguage]'
GO
CREATE TABLE [dbo].[tmp_rg_xx_tblPageLanguage]
(
[fkPageID] [int] NOT NULL,
[fkLanguageBranchID] [int] NOT NULL,
[PageLinkGUID] [uniqueidentifier] NULL,
[fkFrameID] [int] NULL,
[CreatorName] [nvarchar] (255) NULL,
[ChangedByName] [nvarchar] (255) NULL,
[PageGUID] [uniqueidentifier] NOT NULL ROWGUIDCOL CONSTRAINT [DF__tblPageLanguage__PageGUID] DEFAULT (newid()),
[Name] [nvarchar] (255) NULL,
[URLSegment] [nvarchar] (255) NULL,
[LinkURL] [nvarchar] (255) NULL,
[ExternalURL] [nvarchar] (255) NULL,
[ImageURL] [nvarchar] (255) NULL,
[AutomaticLink] [bit] NOT NULL CONSTRAINT [DF__tblPageLanguage__Automatic] DEFAULT ((1)),
[FetchData] [bit] NOT NULL CONSTRAINT [DF__tblPageLanguage__FetchData] DEFAULT ((0)),
[PendingPublish] [bit] NOT NULL CONSTRAINT [DF__tblPageLanguage__PendingPublish] DEFAULT ((0)),
[Created] [datetime] NOT NULL CONSTRAINT [DF__tblPageLanguage__Created] DEFAULT (getdate()),
[Changed] [datetime] NOT NULL CONSTRAINT [DF__tblPageLanguage__Changed] DEFAULT (getdate()),
[Saved] [datetime] NOT NULL CONSTRAINT [DF__tblPageLanguage__Saved] DEFAULT (getdate()),
[StartPublish] [datetime] NULL,
[StopPublish] [datetime] NULL,
[PublishedVersion] [int] NULL
)

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
INSERT INTO [dbo].[tmp_rg_xx_tblPageLanguage]([fkPageID], [fkLanguageBranchID], [fkFrameID], [CreatorName], [ChangedByName], [PageGUID], [Name], [URLSegment], [LinkURL], [ExternalURL], [ImageURL], [AutomaticLink], [FetchData], [PendingPublish], [Created], [Changed], [Saved], [StartPublish], [StopPublish], [PublishedVersion]) SELECT [fkPageID], [fkLanguageBranchID], [fkFrameID], [CreatorName], [ChangedByName], [PageGUID], [Name], [URLSegment], [LinkURL], [ExternalURL], [ImageURL], [AutomaticLink], [FetchData], [PendingPublish], [Created], [Changed], [Saved], [StartPublish], [StopPublish], [PublishedVersion] FROM [dbo].[tblPageLanguage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
--- Update PageLinkGUID from "old" fkPageLinkID
UPDATE [dbo].[tmp_rg_xx_tblPageLanguage]
	SET [PageLinkGUID] = [dbo].[tblPage].[PageGUID]
FROM [dbo].[tblPage] INNER JOIN [dbo].[tblPageLanguage]
	ON [dbo].[tblPage].pkID = [dbo].[tblPageLanguage].fkPageLinkID
WHERE [dbo].[tmp_rg_xx_tblPageLanguage].fkPageID = [dbo].[tblPageLanguage].fkPageID AND 
	[dbo].[tmp_rg_xx_tblPageLanguage].fkLanguageBranchID = [dbo].[tblPageLanguage].fkLanguageBranchID
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
DROP TABLE [dbo].[tblPageLanguage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
sp_rename N'[dbo].[tmp_rg_xx_tblPageLanguage]', N'tblPageLanguage'
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating primary key [PK_tblPageLanguage] on [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] ADD CONSTRAINT [PK_tblPageLanguage] PRIMARY KEY CLUSTERED  ([fkPageID], [fkLanguageBranchID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPageLanguage_PageLinkGUID] on [dbo].[tblPageLanguage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPageLanguage_PageLinkGUID] ON [dbo].[tblPageLanguage] ([PageLinkGUID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPageLanguage_Name] on [dbo].[tblPageLanguage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPageLanguage_Name] ON [dbo].[tblPageLanguage] ([Name])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPageLanguage_ExternalURL] on [dbo].[tblPageLanguage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPageLanguage_ExternalURL] ON [dbo].[tblPageLanguage] ([ExternalURL])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Rebuilding [dbo].[tblWorkPage]'
GO
CREATE TABLE [dbo].[tmp_rg_xx_tblWorkPage]
(
[pkID] [int] NOT NULL IDENTITY(1, 1),
[fkPageID] [int] NOT NULL,
[fkMasterVersionID] [int] NULL,
[PageLinkGUID] [uniqueidentifier] NULL,
[fkFrameID] [int] NULL,
[ArchivePageGUID] [uniqueidentifier] NULL,
[ChangedByName] [nvarchar] (255) NOT NULL,
[NewStatusByName] [nvarchar] (255) NULL,
[Name] [nvarchar] (255) NULL,
[URLSegment] [nvarchar] (255) NULL,
[LinkURL] [nvarchar] (255) NULL,
[ExternalURL] [nvarchar] (255) NULL,
[ImageURL] [nvarchar] (255) NULL,
[VisibleInMenu] [bit] NOT NULL,
[LinkType] [int] NOT NULL CONSTRAINT [DF__tblWorkPa__LinkT__48BAC3E5] DEFAULT ((0)),
[Created] [datetime] NOT NULL CONSTRAINT [DF__tblWorkPa__Creat__49AEE81E] DEFAULT (getdate()),
[Saved] [datetime] NOT NULL CONSTRAINT [DF__tblWorkPa__Saved__4AA30C57] DEFAULT (getdate()),
[StartPublish] [datetime] NULL,
[StopPublish] [datetime] NULL,
[ChildOrderRule] [int] NOT NULL CONSTRAINT [DF__tblWorkPa__Child__4B973090] DEFAULT ((1)),
[PeerOrder] [int] NOT NULL CONSTRAINT [DF__tblWorkPa__PeerO__4C8B54C9] DEFAULT ((100)),
[ReadyToPublish] [bit] NOT NULL CONSTRAINT [DF__tblWorkPa__Ready__4D7F7902] DEFAULT ((0)),
[ChangedOnPublish] [bit] NOT NULL CONSTRAINT [DF__tblWorkPa__Chang__4E739D3B] DEFAULT ((0)),
[HasBeenPublished] [bit] NOT NULL CONSTRAINT [DF__tblWorkPa__HasBe__4F67C174] DEFAULT ((0)),
[Rejected] [bit] NOT NULL CONSTRAINT [DF__tblWorkPa__Rejec__505BE5AD] DEFAULT ((0)),
[DelayedPublish] [bit] NOT NULL CONSTRAINT [DF__tblWorkPa_Delayed] DEFAULT ((0)),
[RejectComment] [nvarchar] (2000) NULL,
[fkLanguageBranchID] [int] NOT NULL CONSTRAINT [DF__tblWorkPa__fkLan__4258C320] DEFAULT ((1))
)

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
SET IDENTITY_INSERT [dbo].[tmp_rg_xx_tblWorkPage] ON
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
INSERT INTO [dbo].[tmp_rg_xx_tblWorkPage]([pkID], [fkPageID], [fkMasterVersionID], [fkFrameID], [ChangedByName], [NewStatusByName], [Name], [URLSegment], [LinkURL], [ExternalURL], [ImageURL], [VisibleInMenu], [LinkType], [Created], [Saved], [StartPublish], [StopPublish], [ChildOrderRule], [PeerOrder], [ReadyToPublish], [ChangedOnPublish], [HasBeenPublished], [Rejected], [DelayedPublish], [RejectComment], [fkLanguageBranchID]) SELECT [pkID], [fkPageID], [fkMasterVersionID], [fkFrameID], [ChangedByName], [NewStatusByName], [Name], [URLSegment], [LinkURL], [ExternalURL], [ImageURL], [VisibleInMenu], [LinkType], [Created], [Saved], [StartPublish], [StopPublish], [ChildOrderRule], [PeerOrder], [ReadyToPublish], [ChangedOnPublish], [HasBeenPublished], [Rejected], [DelayedPublish], [RejectComment], [fkLanguageBranchID] FROM [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
--- Update PageLinkGUID from "old" fkPageLinkID 
UPDATE [dbo].[tmp_rg_xx_tblWorkPage]
	SET [PageLinkGUID] = [dbo].[tblPage].[PageGUID]
FROM [dbo].[tblPage] INNER JOIN [dbo].[tblWorkPage]
	ON [dbo].[tblPage].pkID = [dbo].[tblWorkPage].fkPageLinkID
WHERE [dbo].[tmp_rg_xx_tblWorkPage].pkID = [dbo].[tblWorkPage].pkID
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO

--- Update [ArchivePageGUID] from "old" fkArchivePageID 
UPDATE [dbo].[tmp_rg_xx_tblWorkPage]
	SET [ArchivePageGUID] = [dbo].[tblPage].[PageGUID]
FROM [dbo].[tblPage] INNER JOIN [dbo].[tblWorkPage]
	ON [dbo].[tblPage].pkID = [dbo].[tblWorkPage].fkArchivePageID
WHERE [dbo].[tmp_rg_xx_tblWorkPage].pkID = [dbo].[tblWorkPage].pkID
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
SET IDENTITY_INSERT [dbo].[tmp_rg_xx_tblWorkPage] OFF
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO

DROP TABLE [dbo].[tblWorkPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
sp_rename N'[dbo].[tmp_rg_xx_tblWorkPage]', N'tblWorkPage'
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating primary key [PK_tblWorkPage] on [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] ADD CONSTRAINT [PK_tblWorkPage] PRIMARY KEY CLUSTERED  ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblWorkPage_fkPageID] on [dbo].[tblWorkPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblWorkPage_fkPageID] ON [dbo].[tblWorkPage] ([fkPageID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblWorkPage_fkMasterVersionID] on [dbo].[tblWorkPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblWorkPage_fkMasterVersionID] ON [dbo].[tblWorkPage] ([fkMasterVersionID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblWorkPage_PageLinkGUID] on [dbo].[tblWorkPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblWorkPage_PageLinkGUID] ON [dbo].[tblWorkPage] ([PageLinkGUID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblWorkPage_ArchivePageGUID] on [dbo].[tblWorkPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblWorkPage_ArchivePageGUID] ON [dbo].[tblWorkPage] ([ArchivePageGUID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblWorkPage_ChangedByName] on [dbo].[tblWorkPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblWorkPage_ChangedByName] ON [dbo].[tblWorkPage] ([ChangedByName])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblWorkPage_StatusFields] on [dbo].[tblWorkPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblWorkPage_StatusFields] ON [dbo].[tblWorkPage] ([ReadyToPublish], [DelayedPublish], [HasBeenPublished])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[tblPageLanguageSetting]'
GO
ALTER TABLE [dbo].[tblPageLanguageSetting] ADD
[Active] [bit] NULL CONSTRAINT [DF__tblPageLa__Activ__2B0A656D] DEFAULT (NULL)
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Rebuilding [dbo].[tblPage]'
GO
CREATE TABLE [dbo].[tmp_rg_xx_tblPage]
(
[pkID] [int] NOT NULL IDENTITY(1, 1),
[fkPageTypeID] [int] NOT NULL,
[fkParentID] [int] NULL,
[ArchivePageGUID] [uniqueidentifier] NULL,
[CreatorName] [nvarchar] (255) NULL,
[PageGUID] [uniqueidentifier] NOT NULL ROWGUIDCOL CONSTRAINT [DF__tblPage__PageGUID] DEFAULT (newid()),
[VisibleInMenu] [bit] NOT NULL CONSTRAINT [DF__tblPage__Visible__2E06CDA9] DEFAULT ((1)),
[Deleted] [bit] NOT NULL CONSTRAINT [DF__tblPage__Deleted__2EFAF1E2] DEFAULT ((0)),
[PendingPublish] [bit] NOT NULL CONSTRAINT [DF__tblPage__Pending__31D75E8D] DEFAULT ((0)),
[ChildOrderRule] [int] NOT NULL CONSTRAINT [DF__tblPage__ChildOr__35A7EF71] DEFAULT ((1)),
[PeerOrder] [int] NOT NULL CONSTRAINT [DF__tblPage__PeerOrd__369C13AA] DEFAULT ((100)),
[ExternalFolderID] [int] NULL,
[PublishedVersion] [int] NULL,
[fkMasterLanguageBranchID] [int] NOT NULL CONSTRAINT [DF__tblPage__fkMasterLangaugeBranchID] DEFAULT ((1)),
[PagePath] [varchar] (900) NOT NULL
)

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
SET IDENTITY_INSERT [dbo].[tmp_rg_xx_tblPage] ON
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
INSERT INTO [dbo].[tmp_rg_xx_tblPage]([pkID], [fkPageTypeID], [fkParentID], [CreatorName], [PageGUID], [VisibleInMenu], [Deleted], [PendingPublish], [ChildOrderRule], [PeerOrder], [ExternalFolderID], [PublishedVersion], [fkMasterLanguageBranchID], [PagePath]) SELECT [pkID], [fkPageTypeID], [fkParentID], [CreatorName], [PageGUID], [VisibleInMenu], [Deleted], [PendingPublish], [ChildOrderRule], [PeerOrder], [ExternalFolderID], [PublishedVersion], [fkMasterLanguageBranchID], [PagePath] FROM [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
--- Update ArchivePageGUID from "old" fkArchivePageID
UPDATE [dbo].[tmp_rg_xx_tblPage]
	SET [ArchivePageGUID] = tblPage2.[PageGUID]
FROM [dbo].[tblPage] as tblPage1 INNER JOIN [dbo].[tblPage] as tblPage2
	ON tblPage1.fkArchivePageID = tblPage2.pkID
WHERE [dbo].[tmp_rg_xx_tblPage].pkID = tblPage1.pkID 
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
SET IDENTITY_INSERT [dbo].[tmp_rg_xx_tblPage] OFF
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
DROP TABLE [dbo].[tblPage]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
sp_rename N'[dbo].[tmp_rg_xx_tblPage]', N'tblPage'
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating primary key [PK_tblPage] on [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] ADD CONSTRAINT [PK_tblPage] PRIMARY KEY CLUSTERED  ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPage_fkPageTypeID] on [dbo].[tblPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPage_fkPageTypeID] ON [dbo].[tblPage] ([fkPageTypeID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPage_fkParentID] on [dbo].[tblPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPage_fkParentID] ON [dbo].[tblPage] ([fkParentID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPage_ArchivePageGUID] on [dbo].[tblPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPage_ArchivePageGUID] ON [dbo].[tblPage] ([ArchivePageGUID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPage_PageGUID] on [dbo].[tblPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPage_PageGUID] ON [dbo].[tblPage] ([PageGUID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPage_ExternalFolderID] on [dbo].[tblPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPage_ExternalFolderID] ON [dbo].[tblPage] ([ExternalFolderID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating index [IDX_tblPage_PagePath] on [dbo].[tblPage]'
GO
CREATE NONCLUSTERED INDEX [IDX_tblPage_PagePath] ON [dbo].[tblPage] ([PagePath])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[tblScheduledItem]'
GO
ALTER TABLE [dbo].[tblScheduledItem] ALTER COLUMN [IsRunning] [bit] NOT NULL

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageDefinitionConvertSave]'
GO

ALTER PROCEDURE dbo.netPageDefinitionConvertSave
(
	@PageDefinitionID INT,
	@PageID INT = NULL,
	@WorkPageID INT = NULL,
	@LanguageBranchID INT = NULL,
	@Type INT,
	@Boolean BIT = NULL,
	@IntNumber INT = NULL,
	@FloatNumber FLOAT = NULL,
	@PageType INT = NULL,
	@LinkGuid uniqueidentifier = NULL,
	@PageReference INT = NULL,
	@DateValue DATETIME = NULL,
	@String NVARCHAR(255) = NULL,
	@LongString NTEXT = NULL,
	@DeleteProperty BIT = 0
)
AS
BEGIN
	IF NOT @WorkPageID IS NULL
	BEGIN		
		IF @DeleteProperty=1 OR (@Type=0 AND @Boolean=0) OR @Type > 7
			DELETE FROM tblWorkProperty 
			WHERE fkPageDefinitionID=@PageDefinitionID AND fkWorkPageID=@WorkPageID
		ELSE
		BEGIN
			UPDATE tblWorkProperty
				SET
					Boolean=@Boolean,
					Number=@IntNumber,
					FloatNumber=@FloatNumber,
					PageType=@PageType,
					LinkGuid = @LinkGuid,
					PageLink=@PageReference,
					Date=@DateValue,
					String=@String,
					LongString=@LongString
			WHERE fkPageDefinitionID=@PageDefinitionID AND fkWorkPageID=@WorkPageID
		END
	END
	ELSE
	BEGIN
		IF @DeleteProperty=1 OR (@Type=0 AND @Boolean=0) OR @Type > 7
			DELETE FROM tblProperty 
			WHERE fkPageDefinitionID=@PageDefinitionID AND fkPageID=@PageID AND fkLanguageBranchID = @LanguageBranchID
		ELSE
		BEGIN
			UPDATE tblProperty
				SET
					Boolean=@Boolean,
					Number=@IntNumber,
					FloatNumber=@FloatNumber,
					PageType=@PageType,
					PageLink=@PageReference,
					LinkGuid = @LinkGuid,
					Date=@DateValue,
					String=@String,
					LongString=@LongString
			WHERE fkPageDefinitionID=@PageDefinitionID AND fkPageID=@PageID AND fkLanguageBranchID = @LanguageBranchID
		END
	END
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating [dbo].[netChangeLogGetCountBackwards]'
GO

CREATE PROCEDURE [dbo].[netChangeLogGetCountBackwards]
(
	@from 	                 DATETIME = NULL,
	@to	                     DATETIME = NULL,
	@category 				 INT = 0,
	@action 				 INT = 0,
	@changedBy				 [nvarchar](255) = NULL,
	@startSequence			 BIGINT = 0,
	@count                   BIGINT = 0 OUTPUT)
AS
BEGIN    
        SELECT @count = count(*)
        FROM tblChangeLog TCL
        WHERE 
        (TCL.pkID <= @startSequence) AND
		((@from IS NULL) OR (TCL.ChangeDate >= @from)) AND
		((@to IS NULL) OR (TCL.ChangeDate <= @to)) AND  
        ((@category = 0) OR (@category = TCL.Category)) AND
        ((@action = 0) OR (@action = TCL.Action)) AND
        ((@changedBy IS NULL) OR (@changedBy = TCL.ChangedBy))
		
END
SET ANSI_NULLS ON

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netFindPageCoreDataByID]'
GO

ALTER PROCEDURE [dbo].[netFindPageCoreDataByID]
	@PageID INT
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON

        --- *** use NOLOCK since this may be called during page save if debugging. The code should not be written so this happens, it's to make it work in the debugger ***
	SELECT TOP 1 P.pkID as ID, P.fkPageTypeID as PageTypeID, P.fkParentID as ParentID, P.PageGUID, PL.LinkURL, P.Deleted, P.PendingPublish, PL.Created, PL.Changed, PL.Saved, PL.StartPublish, PL.StopPublish, P.ExternalFolderID, P.fkMasterLanguageBranchID as MasterLanguageBranchID, PL.PageLinkGUID as PageLinkID, PL.AutomaticLink, PL.FetchData
	FROM tblPage AS P WITH (NOLOCK)
	LEFT JOIN tblPageLanguage AS PL ON PL.fkPageID=P.pkID
	WHERE P.pkID = @PageID AND (P.fkMasterLanguageBranchID=PL.fkLanguageBranchID OR P.fkMasterLanguageBranchID IS NULL)
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editSavePageVersionData]'
GO

ALTER PROCEDURE [dbo].[editSavePageVersionData]
(
	@WorkPageID		INT,
	@UserName       NVARCHAR(255),
	@Saved			DATETIME,
	@PageName		NVARCHAR(255)	= NULL,
	@ExternalURL	NVARCHAR(255)	= NULL,
	@Created		DATETIME		= NULL,
	@Changed		BIT				= 0,
	@StartPublish	DATETIME		= NULL,
	@StopPublish	DATETIME		= NULL,
	@ChildOrder		INT				= NULL,
	@PeerOrder		INT				= NULL,
	@PageLinkGUID   UNIQUEIDENTIFIER				= NULL,
	@LinkURL		NVARCHAR(255)	= NULL,
	@LinkType		INT				= 0,
	@FrameID		INT				= NULL,
	@VisibleInMenu	BIT				= NULL,
	@ArchivePageGUID	UNIQUEIDENTIFIER				= NULL,
	@FolderID		INT				= NULL,
	@DelayedPublish	BIT				= NULL,
	@URLSegment		NVARCHAR(255)	= NULL
)
AS
BEGIN
	SET NOCOUNT ON
	SET XACT_ABORT ON
	DECLARE @ChangedDate		DATETIME
	DECLARE @PageID			INT
	DECLARE @PageTypeID		INT
	DECLARE @ParentID			INT
	DECLARE @ExternalFolderID		INT
	DECLARE @MasterPendingPublish		INT
	DECLARE @PageTypeFileName		VARCHAR(100)
	DECLARE @CurrentLangBranchID INT
	DECLARE @IsMasterLang		BIT
	
	/* Pull some useful information from the published page */
	SELECT
		@PageID				= fkPageID,
		@ParentID			= fkParentID,
		@PageTypeID			= fkPageTypeID,
		@ExternalFolderID	= ExternalFolderID,
		@MasterPendingPublish = PendingPublish,
		@PageTypeFileName	= tblPageType.Filename,
		@IsMasterLang		= CASE WHEN tblPage.fkMasterLanguageBranchID=tblWorkPage.fkLanguageBranchID THEN 1 ELSE 0 END,
		@CurrentLangBranchID = fkLanguageBranchID
	FROM
		tblWorkPage
	INNER JOIN tblPage ON tblPage.pkID=tblWorkPage.fkPageID
	INNER JOIN tblPageType ON tblPageType.pkID=tblPage.fkPageTypeID
	WHERE
		tblWorkPage.pkID=@WorkPageID
	
	if (@PageID IS NULL)
	BEGIN
		RAISERROR (N'editSavePageVersionData: The WorkPageId dosen´t exist (WorkPageID=%d)', 16, 1, @WorkPageID)
		RETURN -1
	END			
			
	BEGIN TRAN
		/* Special case for handling external folder id. Only set new value if */
		/* current value of ExternalFolderID is null */
		IF ((@ExternalFolderID IS NULL) AND (@FolderID IS NOT NULL))
		BEGIN
			UPDATE
				tblPage
			SET
				ExternalFolderID=@FolderID
			WHERE
				pkID=@PageID
		END
		/* Set new values for work page */
		UPDATE
			tblWorkPage
		SET
			ChangedByName	= @UserName,
			PageLinkGUID	= @PageLinkGUID,
			ArchivePageGUID	= @ArchivePageGUID,
			fkFrameID		= @FrameID,
			Name			= @PageName,
			LinkURL			= @LinkURL,
			ExternalURL		= @ExternalURL,
			URLSegment		= @URLSegment,
			VisibleInMenu	= @VisibleInMenu,
			LinkType		= @LinkType,
			Created			= COALESCE(@Created, Created),
			Saved			= @Saved,
			StartPublish	= @StartPublish,
			StopPublish		= @StopPublish,
			ChildOrderRule	= @ChildOrder,
			PeerOrder		= COALESCE(@PeerOrder, PeerOrder),
			ChangedOnPublish= @Changed,
			Rejected		= 0,
			DelayedPublish	= COALESCE(@DelayedPublish, DelayedPublish)
		WHERE
			pkID=@WorkPageID
		/* Set some values needed for proper display in edit tree even though we have not yet published the page */
		IF @IsMasterLang=1 AND @MasterPendingPublish = 1
		BEGIN
			UPDATE
				tblPage
			SET
				ChildOrderRule	= @ChildOrder,
				PeerOrder		= @PeerOrder
			WHERE
				pkID=@PageID 
		END

		IF EXISTS(SELECT * FROM tblPageLanguage WHERE fkPageID=@PageID AND fkLanguageBranchID=@CurrentLangBranchID AND PendingPublish=1)
		BEGIN

			UPDATE
				tblPageLanguage
			SET
				Name			= @PageName,
				Created			= @Created,
				Saved			= @Saved,
				URLSegment		= @URLSegment
			WHERE
				fkPageID=@PageID AND fkLanguageBranchID=@CurrentLangBranchID

		END

	COMMIT TRAN
END
SET QUOTED_IDENTIFIER ON 

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageCreateLanguage]'
GO

ALTER PROCEDURE dbo.netPageCreateLanguage
(
	@PageID			INT,
	@WorkPageID		INT,
	@UserName NVARCHAR(255),
	@MaxVersions	INT = NULL,
	@SavedDate		DATETIME = NULL,
	@LanguageBranch	NCHAR(17)
)
AS
BEGIN
	SET NOCOUNT ON
	SET XACT_ABORT ON
	
	DECLARE @LangBranchID		INT
	
	IF @SavedDate IS NULL
		SET @SavedDate = GetDate()
	
	SELECT @LangBranchID = pkID FROM tblLanguageBranch WHERE LanguageID=@LanguageBranch
	IF @LangBranchID IS NULL
	BEGIN
		RAISERROR (N'netPageCreateLanguage: LanguageBranchID is null, possibly empty table tblLanguageBranch', 16, 1, @WorkPageID)
		RETURN 0
	END

	IF NOT EXISTS( SELECT * FROM tblPageLanguage WHERE fkPageID=@PageID )
		UPDATE tblPage SET fkMasterLanguageBranchID=@LangBranchID WHERE pkID=@PageID
	
	INSERT INTO tblPageLanguage(fkPageID, CreatorName, ChangedByName, PendingPublish, fkLanguageBranchID, LinkURL)
	SELECT @PageID, @UserName, @UserName, 1, @LangBranchID, Filename + N'?id=' + CONVERT(NVARCHAR(20), @PageID)
	FROM tblPage
	INNER JOIN tblPageType ON tblPageType.pkID=tblPage.fkPageTypeID
	WHERE tblPage.pkID=@PageID
			
	INSERT INTO tblWorkPage
		(fkPageID,
		ChangedByName,
		PageLinkGUID,
		fkFrameID,
		ArchivePageGUID,
		Name,
		LinkURL,
		ExternalURL,
		ImageURL,
		VisibleInMenu,
		LinkType,
		Created,
		Saved,
		StartPublish,
		StopPublish,
		ChildOrderRule,
		PeerOrder,
		ReadyToPublish,
		fkLanguageBranchID)
	SELECT 
		@PageID,
		COALESCE(@UserName, tblPageLanguage.CreatorName),
		tblPageLanguage.PageLinkGUID,
		tblPageLanguage.fkFrameID,
		tblPage.ArchivePageGUID,
		tblPageLanguage.Name,
		tblPageLanguage.LinkURL,
		tblPageLanguage.ExternalURL,
		tblPageLanguage.ImageURL,
		tblPage.VisibleInMenu,
		CASE tblPageLanguage.AutomaticLink 
			WHEN 1 THEN 
				(CASE
					WHEN tblPageLanguage.PageLinkGUID IS NULL THEN 0	/* EPnLinkNormal */
					WHEN tblPageLanguage.FetchData=1 THEN 4				/* EPnLinkFetchdata */
					ELSE 1												/* EPnLinkShortcut */
				END)
			ELSE
				(CASE 
					WHEN tblPageLanguage.LinkURL=N'#' THEN 3			/* EPnLinkInactive */
					ELSE 2												/* EPnLinkExternal */
				END)
		END AS LinkType ,
		tblPageLanguage.Created,
		@SavedDate,
		tblPageLanguage.StartPublish,
		tblPageLanguage.StopPublish,
		tblPage.ChildOrderRule,
		tblPage.PeerOrder,
		0,
		@LangBranchID
	FROM tblPageLanguage
	INNER JOIN tblPage ON tblPage.pkID=tblPageLanguage.fkPageID
	WHERE 
		tblPageLanguage.fkPageID=@PageID AND tblPageLanguage.fkLanguageBranchID=@LangBranchID
		
		
	RETURN  SCOPE_IDENTITY() 

END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Creating [dbo].[netDynamicPropertyLookup]'
GO

CREATE PROCEDURE dbo.netDynamicPropertyLookup
AS
BEGIN
	SET NOCOUNT ON
	SELECT
		P.fkPageID AS PageID,
		PD.Name AS PropertyName,
		COALESCE(PDT.Property,PD.Property) AS PropertyType,
		EditCaption,
		HelpText,
		CONVERT(INT,Required) AS Required,
		CONVERT(INT,Boolean) AS Boolean,
		Number AS IntNumber,
		FloatNumber,
		PageType,
		PageLink AS PageLinkID,
		LinkGuid,
		Date AS DateValue,
		String,
		LongString,
		P.fkPageDefinitionID,
		TypeName,
		AssemblyName,
		PD.Advanced AS OwnerTab,
		SettingsID,
		LanguageSpecific,
		RTRIM(LB.LanguageID) AS BranchLanguageID,
		FieldOrder,
		DisplayEditUI
	FROM
		tblProperty AS P
	INNER JOIN
		tblLanguageBranch AS LB
	ON
		P.fkLanguageBranchID = LB.pkID
	INNER JOIN
		tblPageDefinition AS PD
	ON
		PD.pkID = P.fkPageDefinitionID
	INNER JOIN
		tblPageDefinitionType AS PDT
	ON
		PDT.pkID = PD.fkPageDefinitionTypeID
	WHERE   
		(LB.Enabled = 1 OR PD.LanguageSpecific = 0) AND
		(PD.fkPageTypeID IS NULL)	
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netChangeLogGetCount]'
GO

ALTER PROCEDURE [dbo].[netChangeLogGetCount]
(
	@from 	                 DATETIME = NULL,
	@to	                     DATETIME = NULL,
	@category 				 INT = 0,
	@action 				 INT = 0,
	@changedBy				 [nvarchar](255) = NULL,
	@startSequence			 BIGINT = 0,
	@count                   BIGINT = 0 OUTPUT)
AS
BEGIN    
        SELECT @count = count(*)
        FROM tblChangeLog TCL
        WHERE 
        ((@startSequence = 0) OR (TCL.pkID >= @startSequence)) AND
		((@from IS NULL) OR (TCL.ChangeDate >= @from)) AND
		((@to IS NULL) OR (TCL.ChangeDate <= @to)) AND  
        ((@category = 0) OR (@category = TCL.Category)) AND
        ((@action = 0) OR (@action = TCL.Action)) AND
        ((@changedBy IS NULL) OR (@changedBy = TCL.ChangedBy))
		
END
SET QUOTED_IDENTIFIER ON 

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPersonalActivityList]'
GO

ALTER PROCEDURE dbo.netPersonalActivityList
(
    @UserName NVARCHAR(255)
)
AS
BEGIN
	SET NOCOUNT ON
	
	/* Not ready */
	SELECT
		W.fkPageID AS PageID,
		W.pkID AS WorkID,
		0 AS VersionStatus,
		W.ChangedByName AS UserName,
		W.Saved AS ItemCreated
	FROM
		tblWorkPage AS W
	INNER JOIN
		tblPage AS P ON P.pkID=W.fkPageID
	WHERE
	    W.ChangedByName=@UserName AND
		W.HasBeenPublished=0 AND
		W.ReadyToPublish=0 AND
		W.Rejected=0 AND
		P.Deleted=0
		
	UNION
	
	/* Ready to publish */
	SELECT DISTINCT
		W.fkPageID AS PageID,
		W.pkID AS WorkID,
		1 AS VersionStatus,
		W.ChangedByName AS UserName,
		W.Saved AS ItemCreated
	FROM
		tblWorkPage AS W
	LEFT JOIN
		tblPage AS P ON P.pkID=W.fkPageID
	WHERE
		W.HasBeenPublished=0 AND
		W.ReadyToPublish=1 AND
		W.DelayedPublish=0 AND
		W.Rejected=0 AND
		P.Deleted=0 AND
		((P.PublishedVersion<>W.pkID) OR (P.PublishedVersion IS NULL))
			
	UNION
	
	/* Rejected pages */
	SELECT 
		W.fkPageID AS PageID,
		W.pkID AS WorkID,
		2 AS VersionStatus,
		W.ChangedByName AS UserName,
		W.Saved AS ItemCreated
	FROM
		tblWorkPage AS W
	INNER JOIN
		tblPage AS P ON P.pkID=W.fkPageID
	WHERE
	    W.ChangedByName=@UserName AND
		W.HasBeenPublished=0 AND
		W.Rejected=1 AND
		P.Deleted=0
		
	ORDER BY VersionStatus DESC, ItemCreated DESC
   		
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageDefinitionConvertList]'
GO

ALTER PROCEDURE dbo.netPageDefinitionConvertList
(
	@PageDefinitionID INT
)
AS
BEGIN

	SELECT 
			fkPageDefinitionID,
			fkPageID,
			NULL AS fkWorkPageID,
			fkLanguageBranchID,
			NULL AS fkUserPropertyID,
			CONVERT(INT,Boolean) AS Boolean,
			Number AS IntNumber,
			FloatNumber,
			PageType,
			LinkGuid,
			PageLink,
			Date AS DateValue,
			String,
			LongString,
			CONVERT(INT,0) AS DeleteProperty
	FROM tblProperty 
	WHERE fkPageDefinitionID=@PageDefinitionID

	UNION ALL
	
	SELECT 
			fkPageDefinitionID,
			NULL AS fkPageID,
			fkWorkPageID,
			NULL AS fkLanguageBranchID,
			NULL AS fkUserPropertyID,
			CONVERT(INT,Boolean) AS Boolean,
			Number AS IntNumber,
			FloatNumber,
			PageType,
			LinkGuid,
			PageLink,
			Date AS DateValue,
			String,
			LongString,
			CONVERT(INT,0) AS DeleteProperty
	FROM tblWorkProperty 
	WHERE fkPageDefinitionID=@PageDefinitionID
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageLanguageSettingListTree]'
GO

ALTER PROCEDURE dbo.netPageLanguageSettingListTree
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	    fkPageID,
        RTRIM(Branch.LanguageID) as LanguageBranch,
        RTRIM(ReplacementBranch.LanguageID) as ReplacementBranch,
        LanguageBranchFallback,
        Active
	FROM 
	    tblPageLanguageSetting
	INNER JOIN 
	    tblLanguageBranch AS Branch 
	ON 
	    Branch.pkID = tblPageLanguageSetting.fkLanguageBranchID
	LEFT JOIN 
	    tblLanguageBranch AS ReplacementBranch 
	ON 
	    ReplacementBranch.pkID = tblPageLanguageSetting.fkReplacementBranchID
	ORDER BY 
	    fkPageID ASC
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netCategoryStringToTable]'
GO

ALTER PROCEDURE dbo.netCategoryStringToTable
(
	@CategoryList	NVARCHAR(2000)
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE		@DotPos INT
	DECLARE		@Category NVARCHAR(255)
	
	WHILE (DATALENGTH(@CategoryList) > 0)
	BEGIN
		SET @DotPos = CHARINDEX(N',', @CategoryList)
		IF @DotPos > 0
			SET @Category = LEFT(@CategoryList,@DotPos-1)
		ELSE
		BEGIN
			SET @Category = @CategoryList
			SET @CategoryList = NULL
		END
		BEGIN TRY
		    INSERT INTO #category SELECT pkID FROM tblCategory WHERE pkID = CAST(@Category AS INT)
		END TRY
		BEGIN CATCH
		     INSERT INTO #category SELECT pkID FROM tblCategory WHERE CategoryName = @Category
		END CATCH
			
		IF (DATALENGTH(@CategoryList) > 0)
			SET @CategoryList = SUBSTRING(@CategoryList,@DotPos+1,255)
	END
	RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageListPaged]'
GO

ALTER PROCEDURE dbo.netPageListPaged
(
	@Binary VARBINARY(8000),
	@Threshold INT = 0
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @Pages TABLE (LocalPageID INT)
	DECLARE	@Length SMALLINT
	DECLARE @Index SMALLINT
	SET @Index = 1
	SET @Length = DATALENGTH(@Binary)
	WHILE (@Index <= @Length)
	BEGIN
		INSERT INTO @Pages VALUES(SUBSTRING(@Binary, @Index, 4))
		SET @Index = @Index + 4
	END

	/* Get all pages included languages*/
	SELECT tblPageLanguage.fkPageID as PageID, tblPageLanguage.fkLanguageBranchID as PageLanguageBranchID FROM tblPageLanguage
		INNER JOIN @Pages on LocalPageID=tblPageLanguage.fkPageID
		ORDER BY tblPageLanguage.fkPageID

/* Get data for page */
	SELECT
		LocalPageID AS PageLinkID,
		NULL AS PageLinkWorkID,
		fkParentID  AS PageParentLinkID,
		fkPageTypeID AS PageTypeID,
		NULL AS PageTypeName,
		CONVERT(INT,VisibleInMenu) AS PageVisibleInMenu,
		ChildOrderRule AS PageChildOrderRule,
		0 AS PagePeerOrderRule,	-- No longer used
		PeerOrder AS PagePeerOrder,
		CONVERT(NVARCHAR(38),tblPage.PageGUID) AS PageGUID,
		ArchivePageGUID AS PageArchiveLinkID,
		ExternalFolderID AS PageFolderID,
		CONVERT(INT,Deleted) AS PageDeleted,
		fkMasterLanguageBranchID AS PageMasterLanguageBranchID,
		CreatorName
	FROM @Pages
	INNER JOIN tblPage ON LocalPageID=tblPage.pkID
	ORDER BY tblPage.pkID

	IF (@@ROWCOUNT = 0)
	BEGIN
		RETURN
	END

	/* Get data for page languages */
	SELECT
		CASE 
			WHEN L.PendingPublish=1 THEN 2			/* EPnWorkStatusCheckedOut */
			ELSE 4									/* EPnWorkStatusPublished */
		END AS PageWorkStatus,
		L.fkPageID AS PageID,
		CASE AutomaticLink
			WHEN 1 THEN
				(CASE
					WHEN L.PageLinkGUID IS NULL THEN 0	/* EPnLinkNormal */
					WHEN L.FetchData=1 THEN 4				/* EPnLinkFetchdata */
					ELSE 1								/* EPnLinkShortcut */
				END)
			ELSE
				(CASE
					WHEN L.LinkURL=N'#' THEN 3				/* EPnLinkInactive */
					ELSE 2								/* EPnLinkExternal */
				END)
		END AS PageShortcutType,
		L.ExternalURL AS PageExternalURL,
		L.PageLinkGUID AS PageShortcutLinkID,
		L.Name AS PageName,
		L.URLSegment AS PageURLSegment,
		L.LinkURL AS PageLinkURL,
		L.Created AS PageCreated,
		L.Changed AS PageChanged,
		L.Saved AS PageSaved,
		L.StartPublish AS PageStartPublish,
		L.StopPublish AS PageStopPublish,
		CONVERT(INT,L.PendingPublish) AS PagePendingPublish,
		L.CreatorName AS PageCreatedBy,
		L.ChangedByName AS PageChangedBy,
		L.fkFrameID AS PageTargetFrame,
		0 AS PageChangedOnPublish,
		0 AS PageDelayedPublish,
		L.fkLanguageBranchID AS PageLanguageBranchID
	FROM @Pages AS P
	INNER JOIN tblPageLanguage AS L ON LocalPageID=L.fkPageID
	ORDER BY L.fkPageID, L.fkLanguageBranchID

	IF (@@ROWCOUNT = 0)
	BEGIN
		RETURN
	END
		
	
	/* Get the properties */
	/* NOTE! The CASE:s for LongString and Guid uses the precomputed LongStringLength to avoid 
	referencing LongString which may slow down the query */
	SELECT
		tblProperty.fkPageID AS PageID,
		tblPageDefinition.Name AS PropertyName,
		tblPageDefinition.LanguageSpecific,
		COALESCE(PDT.Property,tblPageDefinition.Property) AS PropertyType,
		CONVERT(INT, Required) AS Required,
		CONVERT(INT, Boolean) AS Boolean,
		Number AS IntNumber,
		FloatNumber,
		PageType,
		PageLink AS PageLinkID,
		LinkGuid,	
		Date AS DateValue,
		String,
		(CASE 
			WHEN (@Threshold = 0) OR (COALESCE(LongStringLength, 2147483647) < @Threshold) THEN
				LongString
			ELSE
				NULL
		END) AS LongString,
		fkPageDefinitionID,
		tblPageDefinition.Advanced AS OwnerTab,
		TypeName,
		AssemblyName,
		SettingsID,
		tblProperty.fkLanguageBranchID AS LanguageBranchID,
		FieldOrder,
		(CASE 
			WHEN (@Threshold = 0) OR (COALESCE(LongStringLength, 2147483647) < @Threshold) THEN
				NULL
			ELSE
				guid
		END) AS Guid,
		DisplayEditUI
	FROM @Pages
	INNER JOIN tblProperty ON LocalPageID=tblProperty.fkPageID
	INNER JOIN tblPageDefinition ON tblPageDefinition.pkID=tblProperty.fkPageDefinitionID
	LEFT JOIN tblPageDefinitionType AS PDT ON PDT.pkID=tblPageDefinition.fkPageDefinitionTypeID
	WHERE NOT tblPageDefinition.fkPageTypeID IS NULL
	ORDER BY 
		tblProperty.fkPageID,
		tblProperty.fkLanguageBranchID,
		FieldOrder,
		tblProperty.fkPageDefinitionID

	/*Get category information*/
	SELECT 
		fkPageID AS PageID,
		fkCategoryID,
		CategoryType
	FROM tblCategoryPage
	INNER JOIN @Pages ON LocalPageID=tblCategoryPage.fkPageID
	WHERE CategoryType=0
	ORDER BY fkPageID,fkCategoryID

	/* Get access information */
	SELECT
		fkPageID AS PageID,
		tblAccess.Name,
		IsRole,
		AccessMask
	FROM
		@Pages
	INNER JOIN 
	    tblAccess ON LocalPageID=tblAccess.fkPageID
	ORDER BY
		fkPageID
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPropertySearchStringMeta]'
GO

ALTER PROCEDURE dbo.netPropertySearchStringMeta
(
	@PageID				INT,
	@PropertyName 		NVARCHAR(255),
	@UseWildCardsBefore	BIT = 0,
	@UseWildCardsAfter	BIT = 0,
	@String				NVARCHAR(2000) = NULL,
	@LanguageBranch		NCHAR(17) = NULL
)
AS
BEGIN
	DECLARE @SearchString NVARCHAR(2010)
	DECLARE @DynSqlSelect NVARCHAR(2000)
	DECLARE @DynSqlWhere NVARCHAR(2000)
	DECLARE @LangBranchID NCHAR(17)
    
	
	SELECT @LangBranchID=pkID FROM tblLanguageBranch WHERE LanguageID=@LanguageBranch
	IF @LangBranchID IS NULL 
	BEGIN 
		IF @LanguageBranch IS NOT NULL
			RAISERROR('Language branch %s is not defined',16,1, @LanguageBranch)
		ELSE
			SET @LangBranchID = -1
	END
			
	SELECT @SearchString=CASE    WHEN @UseWildCardsBefore=0 AND @UseWildCardsAfter=0 THEN @String
						WHEN @UseWildCardsBefore=1 AND @UseWildCardsAfter=0 THEN N'%' + @String
						WHEN @UseWildCardsBefore=0 AND @UseWildCardsAfter=1 THEN @String + N'%'
						ELSE N'%' + @String + N'%'
					END

	SET @DynSqlSelect = 'SELECT tblPageLanguage.fkPageID FROM tblPageLanguage INNER JOIN tblTree ON tblTree.fkChildID=tblPageLanguage.fkPageID INNER JOIN tblPage ON tblPageLanguage.fkPageID=tblPage.pkID'
	SET @DynSqlWhere = ' WHERE tblTree.fkParentID=@PageID'

	IF (@LangBranchID <> -1)
		SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.fkLanguageBranchID=@LangBranchID'

	IF (@PropertyName = 'PageName')
	BEGIN
		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.Name IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.Name LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageLinkURL')
	BEGIN
		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.LinkURL IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.LinkURL LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageCreatedBy')
	BEGIN
		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.CreatorName IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.CreatorName LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageChangedBy')
	BEGIN
		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.ChangedByName IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.ChangedByName LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageTypeName')
	BEGIN
		SET @DynSqlSelect = @DynSqlSelect + ' INNER JOIN tblPageType ON tblPageType.pkID=tblPage.fkPageTypeID'

		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageType.Name IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageType.Name LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageExternalURL')
	BEGIN
		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.ExternalURL IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.ExternalURL LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageLanguageBranch')
	BEGIN
        SET @DynSqlSelect = @DynSqlSelect + ' INNER JOIN tblLanguageBranch ON tblLanguageBranch.pkid = tblPageLanguage.fklanguagebranchid'
		IF (@String IS NULL)
			SET @DynSqlWhere = @DynSqlWhere + ' AND tblLanguageBranch.languageid IS NULL'
		ELSE
			SET @DynSqlWhere = @DynSqlWhere + ' AND RTRIM(tblLanguageBranch.languageid) LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageShortcutLink')
	BEGIN
	    IF (@String IS NULL)
	        SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.PageLinkGUID IS NULL' 
	    ELSE
	        SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.PageLinkGUID LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageArchiveLink')
	BEGIN
	    IF (@String IS NULL)
	        SET @DynSqlWhere = @DynSqlWhere + ' AND tblPage.ArchivePageGUID IS NULL' 
	    ELSE
	        SET @DynSqlWhere = @DynSqlWhere + ' AND tblPage.ArchivePageGUID LIKE @SearchString'
	END
	ELSE IF (@PropertyName = 'PageURLSegment')
	BEGIN
	    IF (@String IS NULL)
	        SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.URLSegment IS NULL' 
	    ELSE
	        SET @DynSqlWhere = @DynSqlWhere + ' AND tblPageLanguage.URLSegment LIKE @SearchString'
	END

	SET @DynSqlSelect = @DynSqlSelect + @DynSqlWhere
	EXEC sp_executesql @DynSqlSelect, 
		N'@PageID INT, @LangBranchID NCHAR(17), @SearchString NVARCHAR(2010)',
		@PageID=@PageID,
		@LangBranchID=@LangBranchID, 
		@SearchString=@SearchString
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netFindPageCoreDataByPageGuid]'
GO

ALTER PROCEDURE [dbo].[netFindPageCoreDataByPageGuid]
	@PageGuid UNIQUEIDENTIFIER
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON

        --- *** use NOLOCK since this may be called during page save if debugging. The code should not be written so this happens, it's to make it work in the debugger ***
	SELECT TOP 1 P.pkID as ID, P.fkPageTypeID as PageTypeID, P.fkParentID as ParentID, P.PageGUID, PL.LinkURL, P.Deleted, P.PendingPublish, PL.Created, PL.Changed, PL.Saved, PL.StartPublish, PL.StopPublish, P.ExternalFolderID, P.fkMasterLanguageBranchID as MasterLanguageBranchID, PL.PageLinkGUID as PageLinkID, PL.AutomaticLink, PL.FetchData
	FROM tblPage AS P WITH (NOLOCK)
	LEFT JOIN tblPageLanguage AS PL ON PL.fkPageID=P.pkID
	WHERE P.PageGUID = @PageGuid AND (P.fkMasterLanguageBranchID=PL.fkLanguageBranchID OR P.fkMasterLanguageBranchID IS NULL)
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageLanguageSettingUpdate]'
GO


ALTER PROCEDURE dbo.netPageLanguageSettingUpdate
(
	@PageID				INT,
	@LanguageBranch		NCHAR(17),
	@ReplacementBranch	NCHAR(17) = NULL,
	@LanguageBranchFallback NVARCHAR(1000) = NULL,
	@Active				BIT
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @LangBranchID INT
	DECLARE @ReplacementBranchID INT

	SELECT @LangBranchID = pkID FROM tblLanguageBranch WHERE LanguageID = @LanguageBranch
	IF @LangBranchID IS NULL
	BEGIN
		RAISERROR('Language branch "%s" is not defined',16,1, @LanguageBranch)
		RETURN 0
	END

	IF NOT @ReplacementBranch IS NULL
	BEGIN
		SELECT @ReplacementBranchID = pkID FROM tblLanguageBranch WHERE LanguageID = @ReplacementBranch
		IF @ReplacementBranchID IS NULL
		BEGIN
			RAISERROR('Replacement language branch "%s" is not defined',16,1, @ReplacementBranch)
			RETURN 0
		END
	END
	
	IF EXISTS(SELECT * FROM tblPageLanguageSetting WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID)
		UPDATE tblPageLanguageSetting SET
			fkReplacementBranchID	= @ReplacementBranchID,
			LanguageBranchFallback  = @LanguageBranchFallback,
			Active					= @Active
		WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID

	ELSE
		INSERT INTO tblPageLanguageSetting(
				fkPageID,
				fkLanguageBranchID,
				fkReplacementBranchID,
				LanguageBranchFallback,
				Active)
		VALUES(
				@PageID, 
				@LangBranchID,
				@ReplacementBranchID,
				@LanguageBranchFallback,
				@Active
			)
		
	RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netCreatePath]'
GO

ALTER PROCEDURE dbo.netCreatePath
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @RootPage INT

	UPDATE tblPage SET PagePath=''
	SELECT @RootPage=pkID FROM tblPage WHERE fkParentID IS NULL AND PagePath = ''
	UPDATE tblPage SET PagePath='.' WHERE pkID=@RootPage
	
	WHILE (1 = 1)
	BEGIN
	
		UPDATE CHILD SET CHILD.PagePath = PARENT.PagePath + CONVERT(VARCHAR, PARENT.pkID) + '.'
		FROM tblPage CHILD INNER JOIN tblPage PARENT ON CHILD.fkParentId = PARENT.pkID
		WHERE CHILD.PagePath = '' AND PARENT.PagePath <> ''
		
		IF (@@ROWCOUNT = 0)
			BREAK	
	
	END	
	
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPropertySearchValueMeta]'
GO

ALTER PROCEDURE dbo.netPropertySearchValueMeta
(
	@PageID			INT,
	@PropertyName 	NVARCHAR(255),
	@Equals			BIT = 0,
	@NotEquals		BIT = 0,
	@GreaterThan	BIT = 0,
	@LessThan		BIT = 0,
	@Boolean		BIT = NULL,
	@Number			INT = NULL,
	@FloatNumber	FLOAT = NULL,
	@PageType		INT = NULL,
	@PageLink		INT = NULL,
	@Date			DATETIME = NULL,
	@LanguageBranch	NCHAR(17) = NULL
)
AS
BEGIN
	DECLARE @LangBranchID NCHAR(17)
	SELECT @LangBranchID=pkID FROM tblLanguageBranch WHERE LanguageID=@LanguageBranch
	IF @LangBranchID IS NULL 
	BEGIN 
		if @LanguageBranch IS NOT NULL
			RAISERROR('Language branch %s is not defined',16,1, @LanguageBranch)
		else
			SET @LangBranchID = -1
	END
	
	DECLARE @DynSql NVARCHAR(2000)
	DECLARE @compare NVARCHAR(2)
	
	IF (@Equals = 1)
	BEGIN
	    SET @compare = '='
	END
	ELSE IF (@GreaterThan = 1)
	BEGIN
	    SET @compare = '>'
	END
	ELSE IF (@LessThan = 1)
	BEGIN
	    SET @compare = '<'
	END
	ELSE IF (@NotEquals = 1)
	BEGIN
	    SET @compare = '<>'
	END
	ELSE
	BEGIN
	    RAISERROR('No compare condition is defined.',16,1)
	END
	
	SET @DynSql = 'SELECT tblPageLanguage.fkPageID FROM tblPageLanguage INNER JOIN tblTree ON tblTree.fkChildID=tblPageLanguage.fkPageID INNER JOIN tblPage ON tblPage.pkID=tblPageLanguage.fkPageID WHERE tblTree.fkParentID=@PageID'
	IF (@LangBranchID <> -1)
	BEGIN
	    SET @DynSql = @DynSql + ' AND tblPageLanguage.fkLanguageBranchID=@LangBranchID'
	END
	
	IF (@PropertyName = 'PageVisibleInMenu')
	BEGIN
	    SET @DynSql = @DynSql + ' AND tblPage.VisibleInMenu=@Boolean'
	END
	ELSE IF (@PropertyName = 'PageTypeID')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPage.fkPageTypeID = @PageType OR (@PageType IS NULL AND tblPage.fkPageTypeID IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPage.fkPageTypeID' + @compare + '@PageType OR (@PageType IS NULL AND NOT tblPage.fkPageTypeID IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageLink')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.fkPageID = @PageLink OR (@PageLink IS NULL AND tblPageLanguage.fkPageID IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.fkPageID' + @compare + '@PageLink OR (@PageLink IS NULL AND NOT tblPageLanguage.fkPageID IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageParentLink')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPage.fkParentID = @PageLink OR (@PageLink IS NULL AND tblPage.fkParentID IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPage.fkParentID' + @compare + '@PageLink OR (@PageLink IS NULL AND NOT tblPage.fkParentID IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageShortcutLink')
	BEGIN
		SET @DynSql = @DynSql + ' AND ((SELECT pkID FROM tblPage WHERE PageGUID = tblPageLanguage.PageLinkGUID)' + @compare + '@PageLink OR (@PageLink IS NULL AND NOT tblPageLanguage.PageLinkGUID IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageArchiveLink')
	BEGIN
		SET @DynSql = @DynSql + ' AND ((SELECT pkID FROM tblPage WHERE PageGUID = tblPage.ArchivePageGUID)' + @compare + '@PageLink OR (@PageLink IS NULL AND NOT tblPage.ArchivePageGUID IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageChanged')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.Changed = @Date OR (@Date IS NULL AND tblPageLanguage.Changed IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.Changed' + @compare + '@Date OR (@Date IS NULL AND NOT tblPageLanguage.Changed IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageCreated')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.Created = @Date OR (@Date IS NULL AND tblPageLanguage.Created IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.Created' + @compare + '@Date OR (@Date IS NULL AND NOT tblPageLanguage.Created IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageSaved')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.Saved = @Date OR (@Date IS NULL AND tblPageLanguage.Saved IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.Saved' + @compare + '@Date  OR (@Date IS NULL AND NOT tblPageLanguage.Saved IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageStartPublish')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.StartPublish = @Date OR (@Date IS NULL AND tblPageLanguage.StartPublish IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.StartPublish' + @compare + '@Date OR (@Date IS NULL AND NOT tblPageLanguage.StartPublish IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageStopPublish')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.StopPublish = @Date OR (@Date IS NULL AND tblPageLanguage.StopPublish IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPageLanguage.StopPublish' + @compare + '@Date OR (@Date IS NULL AND NOT tblPageLanguage.StopPublish IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageDeleted')
	BEGIN
		SET @DynSql = @DynSql + ' AND tblPage.Deleted = @Boolean'
	END
	ELSE IF (@PropertyName = 'PagePendingPublish')
	BEGIN
		SET @DynSql = @DynSql + ' AND tblPageLanguage.PendingPublish = @Boolean'
	END
	ELSE IF (@PropertyName = 'PageFolderID')
	BEGIN
	    IF (@Equals=1)
	        SET @DynSql = @DynSql + ' AND (tblPage.ExternalFolderID = @Number OR (@Number IS NULL AND tblPage.ExternalFolderID IS NULL))'
	    ELSE
	        SET @DynSql = @DynSql + ' AND (tblPage.ExternalFolderID' + @compare + '@Number OR (@Number IS NULL AND NOT tblPage.ExternalFolderID IS NULL))'
	END
	ELSE IF (@PropertyName = 'PageShortcutType')
	BEGIN
	    IF (@Number=0)
	        SET @DynSql = @DynSql + ' AND tblPageLanguage.AutomaticLink=1 AND tblPageLanguage.PageLinkGUID IS NULL'
	    ELSE IF (@Number=1)
	        SET @DynSql = @DynSql + ' AND tblPageLanguage.AutomaticLink=1 AND NOT tblPageLanguage.PageLinkGUID IS NULL AND tblPageLanguage.FetchData=0'
	    ELSE IF (@Number=2)
	        SET @DynSql = @DynSql + ' AND tblPageLanguage.AutomaticLink=0 AND tblPageLanguage.LinkURL<>N''#'''
	    ELSE IF (@Number=3)
	        SET @DynSql = @DynSql + ' AND tblPageLanguage.AutomaticLink=0 AND tblPageLanguage.LinkURL=N''#'''
	    ELSE IF (@Number=4)
	        SET @DynSql = @DynSql + ' AND tblPageLanguage.AutomaticLink=1 AND tblPageLanguage.FetchData=1'
	END

	EXEC sp_executesql @DynSql, 
		N'@PageID INT, @LangBranchID NCHAR(17), @Boolean BIT, @Number INT, @PageType INT, @PageLink INT, @Date DATETIME',
		@PageID=@PageID,
		@LangBranchID=@LangBranchID, 
		@Boolean=@Boolean,
		@Number=@Number,
		@PageType=@PageType,
		@PageLink=@PageLink,
		@Date=@Date
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageLanguageSettingList]'
GO

ALTER PROCEDURE dbo.netPageLanguageSettingList
@PageID INT
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT	fkPageID,
			RTRIM(Branch.LanguageID) as LanguageBranch,
			RTRIM(ReplacementBranch.LanguageID) as ReplacementBranch,
			LanguageBranchFallback,
			Active
	FROM tblPageLanguageSetting
	INNER JOIN tblLanguageBranch AS Branch ON Branch.pkID = tblPageLanguageSetting.fkLanguageBranchID
	LEFT JOIN tblLanguageBranch AS ReplacementBranch ON ReplacementBranch.pkID = tblPageLanguageSetting.fkReplacementBranchID
	WHERE fkPageID=@PageID
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editDeletePageCheckInternal]'
GO

ALTER PROCEDURE dbo.editDeletePageCheckInternal
AS
BEGIN
	SET NOCOUNT ON
	
    SELECT 
        tblPageLanguage.fkPageID AS pkID, 
        tblPageLanguage.Name,
        PageLink,
        tpl.Name AS FromPage,
        0 AS ReferenceType
    FROM 
        tblProperty 
    INNER JOIN 
        tblPage ON tblProperty.fkPageID=tblPage.pkID
	INNER JOIN 
        tblPageLanguage ON tblPageLanguage.fkPageID=tblPage.pkID
    INNER JOIN
        tblPage AS tp ON PageLink=tp.pkID
    INNER JOIN
		tblPageLanguage AS tpl ON tpl.fkPageID=tp.pkID
    WHERE 
        (tblProperty.fkPageID NOT IN (SELECT pkID FROM #pages)) AND
        (PageLink IN (SELECT pkID FROM #pages)) AND
        tblPage.Deleted=0 AND
		tblPageLanguage.fkLanguageBranchID=tblProperty.fkLanguageBranchID AND
		tpl.fkLanguageBranchID=tp.fkMasterLanguageBranchID
    
    UNION ALL
	
    SELECT
        tblPageLanguage.fkPageID AS pkID,
        tblPageLanguage.Name,
        tp.pkID AS PageLink,
        tpl.Name AS FromPage,
        1 AS ReferenceType
    FROM
        tblPageLanguage
	INNER JOIN
		tblPage ON tblPage.pkID=tblPageLanguage.fkPageID
    INNER JOIN
        tblPage AS tp ON tblPageLanguage.PageLinkGUID = tp.PageGUID
    INNER JOIN
		tblPageLanguage AS tpl ON tpl.fkPageID=tp.pkID
    WHERE
        (tblPageLanguage.fkPageID NOT IN (SELECT pkID FROM #pages)) AND
        (tblPageLanguage.PageLinkGUID IN (SELECT PageGUID FROM #pages)) AND
        tblPage.Deleted=0 AND
		tpl.fkLanguageBranchID=tp.fkMasterLanguageBranchID
    
    UNION ALL
	
    SELECT
        PLinkFrom.pkID,
        PLinkFromLang.Name,
        PLinkTo.pkID AS PageLink,
        PLinkToLang.Name AS FromPage,
        1 AS ReferenceType
    FROM
        tblPageSoftlink
    INNER JOIN
        tblPage PLinkFrom ON PLinkFrom.pkID=tblPageSoftlink.fkPageID
    INNER JOIN
		tblPageLanguage AS PLinkFromLang ON PLinkFromLang.fkPageID=PLinkFrom.pkID
    INNER JOIN
        tblPage PLinkTo ON PLinkTo.pkID=tblPageSoftlink.fkPageLinkID
    INNER JOIN
		tblPageLanguage AS PLinkToLang ON PLinkToLang.fkPageID=PLinkTo.pkID
    WHERE
        (PLinkFrom.pkID NOT IN (SELECT pkID FROM #pages)) AND
        (PLinkTo.pkID IN (SELECT pkID FROM #pages)) AND
        PLinkFrom.Deleted=0 AND
		PLinkFromLang.fkLanguageBranchID=PLinkFrom.fkMasterLanguageBranchID AND
		PLinkToLang.fkLanguageBranchID=PLinkTo.fkMasterLanguageBranchID
        
	UNION ALL
	
    SELECT
        tblPage.pkID,
        tblPageLanguage.Name,
        tp.pkID AS PageLink,
        tpl.Name AS FromPage,
        2 AS ReferenceType
    FROM
        tblPage
    INNER JOIN 
        tblPageLanguage ON tblPageLanguage.fkPageID=tblPage.pkID
    INNER JOIN
        tblPage AS tp ON tblPage.ArchivePageGUID=tp.PageGUID
    INNER JOIN
		tblPageLanguage AS tpl ON tpl.fkPageID=tp.pkID
    WHERE
        (tblPage.pkID NOT IN (SELECT pkID FROM #pages)) AND
        (tblPage.ArchivePageGUID IN (SELECT PageGUID FROM #pages)) AND
        tblPage.Deleted=0 AND
		tpl.fkLanguageBranchID=tp.fkMasterLanguageBranchID AND
		tblPageLanguage.fkLanguageBranchID=tblPage.fkMasterLanguageBranchID

	UNION ALL
	
    SELECT 
        tblPage.pkID AS pkID, 
        tblPageLanguage.Name,
        tblPageTypeDefault.fkArchivePageID,
        tblPageType.Name AS FromPage,
        3 AS ReferenceType
    FROM 
        tblPageTypeDefault
    INNER JOIN
       tblPageType ON tblPageTypeDefault.fkPageTypeID=tblPageType.pkID
    INNER JOIN
        tblPage ON tblPageTypeDefault.fkArchivePageID=tblPage.pkID
	INNER JOIN 
        tblPageLanguage ON tblPageLanguage.fkPageID=tblPage.pkID
    WHERE 
        tblPageTypeDefault.fkArchivePageID IN (SELECT pkID FROM #pages) AND
        tblPageLanguage.fkLanguageBranchID=tblPage.fkMasterLanguageBranchID

    ORDER BY
       ReferenceType
		
    RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageDataLoad]'
GO

ALTER PROCEDURE dbo.netPageDataLoad
(
	@PageID	INT, 
	@LanguageBranchID INT
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @PageTypeID INT

	SELECT @PageTypeID = tblPage.fkPageTypeID FROM tblPage
		WHERE tblPage.pkID=@PageID

	/*This procedure should always return a page (if exist), preferable in requested language else in master language*/
	IF (@LanguageBranchID = -1 OR NOT EXISTS (SELECT Name FROM tblPageLanguage WHERE fkPageID=@PageID AND fkLanguageBranchID = @LanguageBranchID))
		SELECT @LanguageBranchID = fkMasterLanguageBranchID  FROM tblPage
			WHERE tblPage.pkID=@PageID

	/* Get data for page */
	SELECT
		tblPage.pkID AS PageLinkID,
		NULL AS PageLinkWorkID,
		fkParentID  AS PageParentLinkID,
		fkPageTypeID AS PageTypeID,
		NULL AS PageTypeName,
		CONVERT(INT,VisibleInMenu) AS PageVisibleInMenu,
		ChildOrderRule AS PageChildOrderRule,
		PeerOrder AS PagePeerOrder,
		CONVERT(NVARCHAR(38),tblPage.PageGUID) AS PageGUID,
		ArchivePageGUID AS PageArchiveLinkID,
		ExternalFolderID AS PageFolderID,
		CONVERT(INT,Deleted) AS PageDeleted,
		(SELECT ChildOrderRule FROM tblPage AS ParentPage WHERE ParentPage.pkID=tblPage.fkParentID) AS PagePeerOrderRule,
		fkMasterLanguageBranchID AS PageMasterLanguageBranchID,
		CreatorName
	FROM tblPage
	WHERE tblPage.pkID=@PageID

	IF (@@ROWCOUNT = 0)
		RETURN 0
		
	/* Get data for page languages */
	SELECT
		L.fkPageID AS PageID,
		CASE L.AutomaticLink
			WHEN 1 THEN
				(CASE
					WHEN L.PageLinkGUID IS NULL THEN 0	/* EPnLinkNormal */
					WHEN L.FetchData=1 THEN 4				/* EPnLinkFetchdata */
					ELSE 1								/* EPnLinkShortcut */
				END)
			ELSE
				(CASE
					WHEN L.LinkURL=N'#' THEN 3				/* EPnLinkInactive */
					ELSE 2								/* EPnLinkExternal */
				END)
		END AS PageShortcutType,
		L.ExternalURL AS PageExternalURL,
		L.PageLinkGUID AS PageShortcutLinkID,
		L.Name AS PageName,
		L.URLSegment AS PageURLSegment,
		L.LinkURL AS PageLinkURL,
		L.Created AS PageCreated,
		L.Changed AS PageChanged,
		L.Saved AS PageSaved,
		L.StartPublish AS PageStartPublish,
		L.StopPublish AS PageStopPublish,
		CONVERT(INT,L.PendingPublish) AS PagePendingPublish,
		L.CreatorName AS PageCreatedBy,
		L.ChangedByName AS PageChangedBy,
		-- RTRIM(tblPageLanguage.fkLanguageID) AS PageLanguageID,
		L.fkFrameID AS PageTargetFrame,
		0 AS PageChangedOnPublish,
		0 AS PageDelayedPublish,
		L.fkLanguageBranchID AS PageLanguageBranchID,
		CASE 
			WHEN L.PendingPublish=1 THEN 2			/* EPnWorkStatusCheckedOut */
			ELSE 4									/* EPnWorkStatusPublished */
		END AS PageWorkStatus
	FROM tblPageLanguage AS L
	WHERE L.fkPageID=@PageID
		AND L.fkLanguageBranchID=@LanguageBranchID
	
	/* Get the property definitions*/
	SELECT
		@PageID AS PageID,
		tblPageDefinition.Name AS PropertyName,
		tblPageDefinition.LanguageSpecific,
		COALESCE(PDT.Property,tblPageDefinition.Property) AS PropertyType,
		CONVERT(INT, Required) AS Required,
		tblPageDefinition.pkID AS fkPageDefinitionID,
		tblPageDefinition.Advanced AS OwnerTab,
		TypeName,
		AssemblyName,
		SettingsID,
		FieldOrder,
		NULL AS Guid,
		DisplayEditUI
	FROM tblPageDefinition INNER JOIN tblPageType on tblPageDefinition.fkPageTypeID = tblPageType.pkID
		LEFT JOIN tblPageDefinitionType AS PDT ON PDT.pkID=tblPageDefinition.fkPageDefinitionTypeID
	WHERE tblPageDefinition.fkPageTypeID = @PageTypeID
	ORDER BY FieldOrder,tblPageDefinition.pkID

	/* Get the property data for the requested language */
	SELECT
		tblPageDefinition.Name AS PropertyName,
		CONVERT(INT, Boolean) AS Boolean,
		Number AS IntNumber,
		FloatNumber,
		PageType,
		PageLink AS PageLinkID,
		LinkGuid,
		Date AS DateValue,
		String,
		LongString,
		SettingsID,
		tblProperty.fkLanguageBranchID AS LanguageBranchID
	FROM tblProperty
	INNER JOIN tblPageDefinition ON tblPageDefinition.pkID = tblProperty.fkPageDefinitionID
	WHERE tblProperty.fkPageID=@PageID AND NOT tblPageDefinition.fkPageTypeID IS NULL
		AND tblProperty.fkLanguageBranchID = @LanguageBranchID
	ORDER BY tblProperty.fkLanguageBranchID,FieldOrder,tblProperty.fkPageDefinitionID

	/*Get category information*/
	SELECT fkPageID AS PageID,fkCategoryID,CategoryType
	FROM tblCategoryPage
	WHERE fkPageID=@PageID AND CategoryType=0
	ORDER BY fkCategoryID

	/* Get access information */
	SELECT
		fkPageID AS PageID,
		Name,
		IsRole,
		AccessMask
	FROM
		tblAccess
	WHERE 
	    fkPageID=@PageID
	ORDER BY
	    IsRole DESC,
		Name

	/* Get all languages for the page */
	SELECT fkLanguageBranchID as PageLanguageBranchID FROM tblPageLanguage
		WHERE tblPageLanguage.fkPageID=@PageID
		
RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editDeletePageInternal]'
GO

ALTER PROCEDURE [dbo].[editDeletePageInternal]
(
    @PageID INT,
    @ForceDelete INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON
	SET XACT_ABORT ON
	
-- STRUCTURE
	
	-- Make sure we dump structure and features like fetch data before we start off repairing links for pages that should not get deleted
	UPDATE 
	    tblPage 
	SET 
	    fkParentID = NULL,
	    ArchivePageGUID=NULL 
	WHERE 
	    pkID IN ( SELECT pkID FROM #pages )
	    
	UPDATE 
	    tblWorkPage 
	SET 
	    fkMasterVersionID=NULL,
	    PageLinkGUID=NULL,
	    ArchivePageGUID=NULL 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )

-- VERSION DATA

	-- Delete page links, archiving and fetch data pointing to us from external pages
	DELETE FROM 
	    tblWorkProperty 
	WHERE 
	    PageLink IN ( SELECT pkID FROM #pages )
	    
	UPDATE 
	    tblWorkPage 
	SET 
	    ArchivePageGUID = NULL 
	WHERE 
	    ArchivePageGUID IN ( SELECT PageGUID FROM #pages )
	    
	UPDATE 
	    tblWorkPage 
	SET 
	    PageLinkGUID = NULL, 
	    LinkType=0,
	    LinkURL=
		(
			SELECT TOP 1 
			    Filename + N'?id=' + CONVERT(NVARCHAR(20), tblWorkPage.pkID)
			FROM 
			    tblPageType
			WHERE 
			    tblPageType.pkID=(SELECT fkPageTypeID FROM tblPage WHERE tblPage.pkID=tblWorkPage.fkPageID)
		)
	 WHERE 
	    PageLinkGUID IN ( SELECT PageGUID FROM #pages )
	
	-- Remove workproperties,workcategories and finally the work versions themselves
	DELETE FROM 
	    tblWorkProperty 
	WHERE 
	    fkWorkPageID IN ( SELECT pkID FROM tblWorkPage WHERE fkPageID IN ( SELECT pkID FROM #pages ) )
	    
	DELETE FROM 
	    tblWorkCategory 
	WHERE 
	    fkWorkPageID IN ( SELECT pkID FROM tblWorkPage WHERE fkPageID IN ( SELECT pkID FROM #pages ) )
	    
	DELETE FROM 
	    tblWorkPage 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )

-- PUBLISHED PAGE DATA

	IF (@ForceDelete IS NOT NULL)
	BEGIN
		DELETE FROM 
		    tblProperty 
		WHERE 
		    PageLink IN (SELECT pkID FROM #pages)
	END
	ELSE
	BEGIN
		/* Default action: Only delete references from pages in wastebasket */
		DELETE FROM 
			tblProperty
		FROM 
		    tblProperty AS P
		INNER JOIN 
		    tblPage ON P.fkPageID=tblPage.pkID
		WHERE
			tblPage.Deleted=1 AND
			P.PageLink IN (SELECT pkID FROM #pages)
	END

	DELETE FROM 
	    tblPropertyDefault 
	WHERE 
	    PageLink IN ( SELECT pkID FROM #pages )
	    
	UPDATE 
	    tblPage 
	SET 
	    ArchivePageGUID = NULL 
	WHERE 
	    ArchivePageGUID IN ( SELECT PageGUID FROM #pages )

	-- Remove fetch data from any external pages pointing to us

	UPDATE 
	    tblPageLanguage 
	SET     
	    PageLinkGUID = NULL, 
	    FetchData=0,
	    LinkURL=
		(
			SELECT TOP 1 
			    Filename + N'?id=' + CONVERT(NVARCHAR(20), tblPageLanguage.fkPageID)
			FROM 
			    tblPageType
			WHERE 
			    tblPageType.pkID=(SELECT tblPage.fkPageTypeID FROM tblPage WHERE tblPage.pkID=tblPageLanguage.fkPageID)
		)
	 WHERE 
	    PageLinkGUID IN ( SELECT PageGUID FROM #pages )

	-- Remove ALC, categories and the properties
	DELETE FROM 
	    tblCategoryPage 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )
	    
	DELETE FROM 
	    tblProperty 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )
	    
	DELETE FROM 
	    tblAccess 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )

-- KEYWORDS AND INDEXING
	
	DELETE FROM 
	    tblPageSoftlink 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )
	    
	DELETE FROM 
	    tblPageKeyword 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )

-- PAGETYPES
	    
	UPDATE 
	    tblPageTypeDefault 
	SET 
	    fkArchivePageID=NULL 
	WHERE fkArchivePageID IN (SELECT pkID FROM #pages)

-- PAGE/TREE

	DELETE FROM 
	    tblTree 
	WHERE 
	    fkChildID IN ( SELECT pkID FROM #pages )
	    
	DELETE FROM 
	    tblTree 
	WHERE 
	    fkParentID IN ( SELECT pkID FROM #pages )
	    
	DELETE FROM 
	    tblPageLanguage 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )
	    
	DELETE FROM 
	    tblPageLanguageSetting 
	WHERE 
	    fkPageID IN ( SELECT pkID FROM #pages )
   
	DELETE FROM
	    tblPage 
	WHERE 
	    pkID IN ( SELECT pkID FROM #pages )

END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editCreatePageVersion]'
GO

ALTER PROCEDURE dbo.editCreatePageVersion
(
	@PageID			INT,
	@WorkPageID		INT,
	@UserName		NVARCHAR(255),
	@MaxVersions	INT = NULL,
	@SavedDate		DATETIME = NULL,
	@LanguageBranch	NCHAR(17)
)
AS
BEGIN
	SET NOCOUNT ON
	SET XACT_ABORT ON
	
	DECLARE @NewWorkPageID		INT
	DECLARE @DeleteWorkPageID	INT
	DECLARE @ObsoleteVersions	INT
	DECLARE @retval				INT
	DECLARE @IsMasterLang		BIT
	DECLARE @LangBranchID		INT
	
	IF @SavedDate IS NULL
		SET @SavedDate = GetDate()
	
	SELECT @LangBranchID = pkID FROM tblLanguageBranch WHERE LanguageID=@LanguageBranch
	IF @LangBranchID IS NULL
	BEGIN
		RAISERROR (N'editCreatePageVersion: LanguageBranchID is null, possibly empty table tblLanguageBranch', 16, 1, @WorkPageID)
		RETURN 0
	END

	IF (@WorkPageID IS NULL OR @WorkPageID=0 )
	BEGIN
		/* If we have a published version use it, else the latest saved version */
		IF EXISTS(SELECT * FROM tblPageLanguage WHERE PendingPublish=1 AND fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID)
			SELECT TOP 1 @WorkPageID=pkID FROM tblWorkPage WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID ORDER BY Saved DESC
		ELSE
			SELECT @WorkPageID=PublishedVersion FROM tblPageLanguage WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID
	END

	IF EXISTS( SELECT * FROM tblPage WHERE pkID=@PageID AND fkMasterLanguageBranchID IS NULL )
		UPDATE tblPage SET fkMasterLanguageBranchID=@LangBranchID WHERE pkID=@PageID
	
	SELECT @IsMasterLang = CASE WHEN @LangBranchID=fkMasterLanguageBranchID THEN 1 ELSE 0 END FROM tblPage WHERE pkID=@PageID
	
	BEGIN TRAN
	
		IF NOT EXISTS (SELECT * FROM tblPageLanguage 
						WHERE tblPageLanguage.fkPageID=@PageID
						AND fkLanguageBranchID=@LangBranchID)
		BEGIN
			INSERT INTO tblPageLanguage(fkPageID, CreatorName, ChangedByName, PendingPublish, fkLanguageBranchID, LinkURL)
			SELECT @PageID, @UserName, @UserName, 1, @LangBranchID, Filename + N'?id=' + CONVERT(NVARCHAR(20), @PageID)
			FROM tblPage
			INNER JOIN tblPageType ON tblPageType.pkID=tblPage.fkPageTypeID
			WHERE tblPage.pkID=@PageID
		END
	
		/* Create a new version of this page */
		INSERT INTO tblWorkPage
			(fkPageID,
			fkMasterVersionID,
			ChangedByName,
			PageLinkGUID,
			fkFrameID,
			ArchivePageGUID,
			Name,
			LinkURL,
			ExternalURL,
			ImageURL,
			VisibleInMenu,
			LinkType,
			Created,
			Saved,
			StartPublish,
			StopPublish,
			ChildOrderRule,
			PeerOrder,
			ReadyToPublish,
			fkLanguageBranchID)
		SELECT 
			fkPageID,
			@WorkPageID,
			@UserName,
			PageLinkGUID,
			fkFrameID,
			ArchivePageGUID,
			Name,
			LinkURL,
			ExternalURL,
			ImageURL,
			VisibleInMenu,
			LinkType,
			Created,
			@SavedDate,
			StartPublish,
			StopPublish,
			ChildOrderRule,
			PeerOrder,
			0,
			@LangBranchID
		FROM 
			tblWorkPage 
		WHERE 
			pkID=@WorkPageID
	
		IF (@@ROWCOUNT = 1)
		BEGIN
			/* Remember version number */
			SET @NewWorkPageID= SCOPE_IDENTITY() 
			/* Copy all properties as well */
			INSERT INTO tblWorkProperty
				(fkPageDefinitionID,
				fkWorkPageID,
				Boolean,
				Number,
				FloatNumber,
				PageType,
				PageLink,
				Date,
				String,
				LongString,
                LinkGuid)          
			SELECT
				fkPageDefinitionID,
				@NewWorkPageID,
				Boolean,
				Number,
				FloatNumber,
				PageType,
				PageLink,
				Date,
				String,
				LongString,
                LinkGuid
			FROM
				tblWorkProperty
			INNER JOIN tblPageDefinition ON tblPageDefinition.pkID=tblWorkProperty.fkPageDefinitionID
			WHERE
				fkWorkPageID=@WorkPageID
				AND (tblPageDefinition.LanguageSpecific=1 OR @IsMasterLang=1)--Only lang specific on non-master 
				
			/* Finally take care of categories */
			INSERT INTO tblWorkCategory
				(fkWorkPageID,
				fkCategoryID,
				CategoryType)
			SELECT
				@NewWorkPageID,
				fkCategoryID,
				CategoryType
			FROM
				tblWorkCategory
			WHERE
				fkWorkPageID=@WorkPageID
				AND (CategoryType<>0 OR @IsMasterLang=1)--No page category on languages
		END
		ELSE
		BEGIN
			/* We did not have anything corresponding to the WorkPageID, create new work page from tblPage */
			INSERT INTO tblWorkPage
				(fkPageID,
				ChangedByName,
				PageLinkGUID,
				fkFrameID,
				ArchivePageGUID,
				Name,
				LinkURL,
				ExternalURL,
				ImageURL,
				VisibleInMenu,
				LinkType,
				Created,
				Saved,
				StartPublish,
				StopPublish,
				ChildOrderRule,
				PeerOrder,
				ReadyToPublish,
				fkLanguageBranchID)
			SELECT 
				@PageID,
				COALESCE(@UserName, tblPageLanguage.CreatorName),
				tblPageLanguage.PageLinkGUID,
				tblPageLanguage.fkFrameID,
				tblPage.ArchivePageGUID,
				tblPageLanguage.Name,
				tblPageLanguage.LinkURL,
				tblPageLanguage.ExternalURL,
				tblPageLanguage.ImageURL,
				tblPage.VisibleInMenu,
				CASE tblPageLanguage.AutomaticLink 
					WHEN 1 THEN 
						(CASE
							WHEN tblPageLanguage.PageLinkGUID IS NULL THEN 0	/* EPnLinkNormal */
							WHEN tblPageLanguage.FetchData=1 THEN 4				/* EPnLinkFetchdata */
							ELSE 1								/* EPnLinkShortcut */
						END)
					ELSE
						(CASE 
							WHEN tblPageLanguage.LinkURL=N'#' THEN 3				/* EPnLinkInactive */
							ELSE 2								/* EPnLinkExternal */
						END)
				END AS LinkType ,
				tblPageLanguage.Created,
				@SavedDate,
				tblPageLanguage.StartPublish,
				tblPageLanguage.StopPublish,
				tblPage.ChildOrderRule,
				tblPage.PeerOrder,
				0,
				@LangBranchID
			FROM tblPageLanguage
			INNER JOIN tblPage ON tblPage.pkID=tblPageLanguage.fkPageID
			WHERE 
				tblPageLanguage.fkPageID=@PageID AND tblPageLanguage.fkLanguageBranchID=@LangBranchID

			IF (@@ROWCOUNT = 1)
			BEGIN
				/* Remember version number */
				SET @NewWorkPageID= SCOPE_IDENTITY() 
				/* Copy all non-dynamic properties as well */
				INSERT INTO tblWorkProperty
					(fkPageDefinitionID,
					fkWorkPageID,
					Boolean,
					Number,
					FloatNumber,
					PageType,
					PageLink,
					Date,
					String,
					LongString,
                    LinkGuid)
				SELECT
					P.fkPageDefinitionID,
					@NewWorkPageID,
					P.Boolean,
					P.Number,
					P.FloatNumber,
					P.PageType,
					P.PageLink,
					P.Date,
					P.String,
					P.LongString,
                    P.LinkGuid
				FROM
					tblProperty AS P
				INNER JOIN
					tblPageDefinition AS PD ON P.fkPageDefinitionID=PD.pkID
				WHERE
					P.fkPageID=@PageID AND (PD.fkPageTypeID IS NOT NULL)
					AND P.fkLanguageBranchID = @LangBranchID
					AND (PD.LanguageSpecific=1 OR @IsMasterLang=1)--Only lang specific on non-master 
					
				/* Finally take care of categories */
				INSERT INTO tblWorkCategory
					(fkWorkPageID,
					fkCategoryID,
					CategoryType)
				SELECT
					@NewWorkPageID,
					fkCategoryID,
					CategoryType
				FROM
					tblCategoryPage
				LEFT JOIN
					tblPageDefinition AS PD ON tblCategoryPage.CategoryType = PD.pkID
				WHERE
					tblCategoryPage.fkPageID=@PageID 
					AND (PD.fkPageTypeID IS NOT NULL OR tblCategoryPage.CategoryType = 0) --Not dynamic properties
					AND (CategoryType<>0 OR @IsMasterLang=1) --No page category on languages
			END
			ELSE
			BEGIN
				ROLLBACK TRAN
				RAISERROR (N'Failed to create new version for page %d', 16, 1, @PageID)
				RETURN 0
			END
		END

		COMMIT TRAN
			
	RETURN @NewWorkPageID
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[netPageDataLoadVersion]'
GO

ALTER PROCEDURE dbo.netPageDataLoadVersion
(
	@PageID	INT,
	@WorkID INT,
	@LangBranchID INT
)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @CommonPropsWorkID INT
	DECLARE @IsMasterLanguage BIT
    DECLARE @PageTypeID INT

	IF @WorkID IS NULL
	BEGIN
		IF @LangBranchID IS NULL OR NOT EXISTS(SELECT * FROM tblWorkPage WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID)
			SELECT @LangBranchID=COALESCE(fkMasterLanguageBranchID,1) FROM tblPage WHERE pkID=@PageID

		SELECT @WorkID=PublishedVersion FROM tblPageLanguage WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID AND PendingPublish=0
		IF (@WorkID IS NULL OR @WorkID=0)
		BEGIN
			SELECT TOP 1 @WorkID=pkID FROM tblWorkPage WHERE fkPageID=@PageID AND fkLanguageBranchID=@LangBranchID ORDER BY Saved DESC
		END
		
		IF (@WorkID IS NULL OR @WorkID=0)
		BEGIN
			EXEC netPageDataLoad @PageID=@PageID, @LanguageBranchID=@LangBranchID
			RETURN 0
		END		
	END
	
	/*Get the page type for the requested page*/
	SELECT @PageTypeID = tblPage.fkPageTypeID FROM tblPage
		WHERE tblPage.pkID=@PageID

	/* Get Language branch from page version*/
	SELECT @LangBranchID=fkLanguageBranchID FROM tblWorkPage WHERE pkID=@WorkID

	SELECT @IsMasterLanguage = CASE WHEN EXISTS(SELECT * FROM tblPage WHERE pkID=@PageID AND fkMasterLanguageBranchID=@LangBranchID) THEN  1 ELSE 0 END
	IF (@IsMasterLanguage = 0)
	BEGIN
		IF EXISTS(SELECT * FROM tblPage WHERE PendingPublish=1 AND pkID=@PageID)
			SELECT TOP 1 @CommonPropsWorkID=tblWorkPage.pkID 
			FROM tblWorkPage 
			INNER JOIN tblPage ON tblPage.pkID=tblWorkPage.fkPageID
			WHERE tblWorkPage.fkPageID=@PageID AND tblWorkPage.fkLanguageBranchID=tblPage.fkMasterLanguageBranchID
			ORDER BY tblWorkPage.Saved DESC
		ELSE
			SELECT @CommonPropsWorkID=tblPageLanguage.PublishedVersion 
			FROM tblPageLanguage 
			INNER JOIN tblPage ON tblPage.pkID=tblPageLanguage.fkPageID
			WHERE tblPage.pkID=@PageID AND tblPageLanguage.fkLanguageBranchID=tblPage.fkMasterLanguageBranchID

		/* Get data for page for non-master language*/
		SELECT
			tblPage.pkID AS PageLinkID,
			tblWorkPage.pkID AS PageLinkWorkID,
			fkParentID  AS PageParentLinkID,
			fkPageTypeID AS PageTypeID,
			NULL AS PageTypeName,
			CONVERT(INT,tblPage.VisibleInMenu) AS PageVisibleInMenu,
			tblPage.ChildOrderRule AS PageChildOrderRule,
			tblPage.PeerOrder AS PagePeerOrder,
			CONVERT(NVARCHAR(38),tblPage.PageGUID) AS PageGUID,
			tblPage.ArchivePageGUID AS PageArchiveLinkID,
			ExternalFolderID AS PageFolderID,
			CONVERT(INT,Deleted) AS PageDeleted,
			(SELECT ChildOrderRule FROM tblPage AS ParentPage WHERE ParentPage.pkID=tblPage.fkParentID) AS PagePeerOrderRule,
			fkMasterLanguageBranchID AS PageMasterLanguageBranchID,
			CreatorName
		FROM
			tblWorkPage
		INNER JOIN
			tblPage
		ON
			tblPage.pkID = tblWorkPage.fkPageID
		WHERE
			tblPage.pkID = @PageID
		AND
			tblWorkPage.pkID = @WorkID	
	END
	ELSE
	BEGIN
		/* Get data for page for master language*/
		SELECT
			tblPage.pkID AS PageLinkID,
			tblWorkPage.pkID AS PageLinkWorkID,
			fkParentID  AS PageParentLinkID,
			fkPageTypeID AS PageTypeID,
			NULL AS PageTypeName,
			CONVERT(INT,tblWorkPage.VisibleInMenu) AS PageVisibleInMenu,
			tblWorkPage.ChildOrderRule AS PageChildOrderRule,
			tblWorkPage.PeerOrder AS PagePeerOrder,
			CONVERT(NVARCHAR(38),tblPage.PageGUID) AS PageGUID,
			tblWorkPage.ArchivePageGUID AS PageArchiveLinkID,
			ExternalFolderID AS PageFolderID,
			CONVERT(INT,Deleted) AS PageDeleted,
			(SELECT ChildOrderRule FROM tblPage AS ParentPage WHERE ParentPage.pkID=tblPage.fkParentID) AS PagePeerOrderRule,
			fkMasterLanguageBranchID AS PageMasterLanguageBranchID,
			tblPage.CreatorName
		FROM tblWorkPage
		INNER JOIN tblPage ON tblPage.pkID=tblWorkPage.fkPageID
		WHERE tblPage.pkID=@PageID AND tblWorkPage.pkID=@WorkID
	END

	IF (@@ROWCOUNT = 0)
		RETURN 0
		
	/* Get data for page languages */
	SELECT
		CASE
			WHEN PublishedVersion=W.pkID THEN 4	/* EPnWorkStatusPublished */
			WHEN W.HasBeenPublished=1 THEN 5		/* EPnWorkStatusPrevious */
			WHEN W.Rejected=1 THEN 1			/* EPnWorkStatusRejected */
			WHEN W.ReadyToPublish=1 THEN 3		/* EPnWorkStatusCheckedIn */
			ELSE 2						/* EPnWorkStatusCheckedOut */
		END AS PageWorkStatus,
		W.fkPageID AS PageID,
		W.LinkType AS PageShortcutType,
		W.ExternalURL AS PageExternalURL,
		W.PageLinkGUID AS PageShortcutLinkID,
		W.Name AS PageName,
		W.URLSegment AS PageURLSegment,
		W.LinkURL AS PageLinkURL,
		W.Created AS PageCreated,
		tblPageLanguage.Changed AS PageChanged,
		W.Saved AS PageSaved,
		W.StartPublish AS PageStartPublish,
		W.StopPublish AS PageStopPublish,
		CONVERT(INT,PendingPublish) AS PagePendingPublish,
		tblPageLanguage.CreatorName AS PageCreatedBy,
		W.ChangedByName AS PageChangedBy,
		-- RTRIM(W.fkLanguageID) AS PageLanguageID,
		W.fkFrameID AS PageTargetFrame,
		W.ChangedOnPublish AS PageChangedOnPublish,
		W.DelayedPublish AS PageDelayedPublish,
		W.fkLanguageBranchID AS PageLanguageBranchID
	FROM tblWorkPage AS W
	INNER JOIN tblPageLanguage ON tblPageLanguage.fkPageID=W.fkPageID
	WHERE tblPageLanguage.fkLanguageBranchID=W.fkLanguageBranchID
		AND W.pkID=@WorkID
	
	/* Get the property definitions*/
	SELECT
		@PageID AS PageID,
		tblPageDefinition.Name AS PropertyName,
		tblPageDefinition.LanguageSpecific,
		COALESCE(PDT.Property,tblPageDefinition.Property) AS PropertyType,
		CONVERT(INT, Required) AS Required,
		tblPageDefinition.pkID AS fkPageDefinitionID,
		tblPageDefinition.Advanced AS OwnerTab,
		TypeName,
		AssemblyName,
		SettingsID,
		FieldOrder,
		NULL AS Guid,
		DisplayEditUI
	FROM tblPageDefinition INNER JOIN tblPageType on tblPageDefinition.fkPageTypeID = tblPageType.pkID
		LEFT JOIN tblPageDefinitionType AS PDT ON PDT.pkID=tblPageDefinition.fkPageDefinitionTypeID
	WHERE tblPageDefinition.fkPageTypeID = @PageTypeID
	ORDER BY FieldOrder,tblPageDefinition.pkID

	/* Get the property data */
	SELECT
		tblPageDefinition.Name AS PropertyName,
		CONVERT(INT, Boolean) AS Boolean,
		Number AS IntNumber,
		FloatNumber,
		PageType,
		PageLink AS PageLinkID,
		LinkGuid,
		Date AS DateValue,
		String,
		LongString,
	    SettingsID,
		tblWorkPage.fkLanguageBranchID AS LanguageBranchID
	FROM tblWorkProperty
	INNER JOIN tblWorkPage ON tblWorkPage.pkID=tblWorkProperty.fkWorkPageID
	INNER JOIN tblPageDefinition ON tblPageDefinition.pkID=tblWorkProperty.fkPageDefinitionID
	WHERE (tblWorkProperty.fkWorkPageID=@WorkID OR (tblWorkProperty.fkWorkPageID=@CommonPropsWorkID AND tblPageDefinition.LanguageSpecific=0 AND @IsMasterLanguage=0))
		   AND NOT tblPageDefinition.fkPageTypeID IS NULL
	ORDER BY FieldOrder,tblWorkProperty.fkPageDefinitionID

	/*Get built in category information*/
	SELECT
		fkPageID
	AS
		PageID,
		fkCategoryID,
		CategoryType,
		NULL
	FROM
		tblWorkCategory
	INNER JOIN
		tblWorkPage
	ON
		tblWorkPage.pkID = tblWorkCategory.fkWorkPageID
	WHERE
		tblWorkPage.pkID = CASE WHEN @IsMasterLanguage = 0 THEN @CommonPropsWorkID ELSE @WorkID END
	AND
		CategoryType = 0
	ORDER BY
		fkCategoryID

	/* Get access information */
	SELECT
		fkPageID AS PageID,
		Name,
		IsRole,
		AccessMask
	FROM
		tblAccess
	WHERE 
	    fkPageID=@PageID
	ORDER BY
	    IsRole DESC,
		Name

	/* Get all languages for the page */
	SELECT fkLanguageBranchID as PageLanguageBranchID FROM tblPageLanguage
		WHERE tblPageLanguage.fkPageID=@PageID

	RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editDeletePageCheck]'
GO

ALTER PROCEDURE dbo.editDeletePageCheck
(
    @PageID			INT
)
AS
BEGIN
    SET NOCOUNT ON
    SET XACT_ABORT ON
    
    BEGIN TRAN
    
    /* Get all pages to delete (= PageID and all its childs) */
	CREATE TABLE #pages
	(
		pkID	INT PRIMARY KEY,
		PageGUID UNIQUEIDENTIFIER
	)
	INSERT INTO #pages (pkID) 
	SELECT 
		fkChildID 
	FROM 
		tblTree 
	WHERE fkParentID=@PageID
	UNION ALL
	SELECT @PageID
	
	UPDATE #pages 
		SET PageGUID = tblPage.PageGUID
	FROM tblPage INNER JOIN #pages ON #pages.pkID=tblPage.pkID
	
	EXEC editDeletePageCheckInternal
    
    DROP TABLE #pages
    
    COMMIT TRAN
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editDeleteChilds]'
GO

ALTER PROCEDURE dbo.editDeleteChilds
(
    @PageID			INT,
    @ForceDelete	INT = NULL
)
AS
BEGIN
    SET NOCOUNT ON
    SET XACT_ABORT ON
    DECLARE @retval INT
    
    BEGIN TRAN
    
    /* Get all pages to delete (all childs of PageID) */
	CREATE TABLE #pages
	(
		pkID	INT PRIMARY KEY,
		PageGUID UNIQUEIDENTIFIER
	)
	INSERT INTO #pages (pkID) 
	SELECT 
		fkChildID 
	FROM 
		tblTree 
	WHERE fkParentID=@PageID
	
	UPDATE #pages 
		SET PageGUID = tblPage.PageGUID
	FROM tblPage INNER JOIN #pages ON #pages.pkID=tblPage.pkID
	
	EXEC @retval=editDeletePageInternal @PageID=@PageID, @ForceDelete=@ForceDelete
	    
    DROP TABLE #pages
    
    COMMIT TRAN
    
    RETURN @retval
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editDeleteChildsCheck]'
GO

ALTER PROCEDURE dbo.editDeleteChildsCheck
(
    @PageID			INT
)
AS
BEGIN
    SET NOCOUNT ON
    SET XACT_ABORT ON
    
    BEGIN TRAN
    
    /* Get all pages to delete (all childs of PageID) */
	CREATE TABLE #pages
	(
		pkID	INT PRIMARY KEY,
		PageGUID UNIQUEIDENTIFIER
	)
	INSERT INTO #pages (pkID) 
	SELECT 
		fkChildID 
	FROM 
		tblTree 
	WHERE fkParentID=@PageID
	
	UPDATE #pages 
		SET PageGUID = tblPage.PageGUID
	FROM tblPage INNER JOIN #pages ON #pages.pkID=tblPage.pkID
	
	EXEC editDeletePageCheckInternal
    
    DROP TABLE #pages
    
    COMMIT TRAN
    
    RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editDeletePage]'
GO

ALTER PROCEDURE dbo.editDeletePage
(
    @PageID			INT,
    @ForceDelete	INT = NULL
)
AS
BEGIN
    SET NOCOUNT ON
    SET XACT_ABORT ON
    
    DECLARE @retval INT
    DECLARE @ParentID INT
    
    /* Get all pages to delete (= PageID and all its childs) */
	CREATE TABLE #pages
	(
		pkID	INT PRIMARY KEY,
		PageGUID UNIQUEIDENTIFIER
	)
	INSERT INTO #pages (pkID) 
	SELECT 
		fkChildID 
	FROM 
		tblTree 
	WHERE fkParentID=@PageID
	UNION
	SELECT @PageID
	
	UPDATE #pages 
		SET PageGUID = tblPage.PageGUID
	FROM tblPage INNER JOIN #pages ON #pages.pkID=tblPage.pkID
	
	SELECT @ParentID=fkParentID FROM tblPage WHERE pkID=@PageID
	EXEC @retval=editDeletePageInternal @PageID=@PageID, @ForceDelete=@ForceDelete
			    
    DROP TABLE #pages
    
    RETURN @retval
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[editPublishPageVersion]'
GO

ALTER PROCEDURE dbo.editPublishPageVersion
(
	@WorkPageID	INT,
	@UserName NVARCHAR(255),
	@MaxVersions INT = NULL,
	@NoWorkflow BIT = 1,
	@PublishedDate DATETIME = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	SET XACT_ABORT ON
	DECLARE @PageID INT
	DECLARE @retval INT
	DECLARE @FirstPublish BIT
	DECLARE @ParentID INT
	DECLARE @LangBranchID INT
	DECLARE @IsMasterLang BIT
	DECLARE @IsMasterLangPendingPublish BIT
	DECLARE @StartPublish DATETIME

	/* Verify that we have a page to publish */
	SELECT	@PageID=fkPageID,
			@LangBranchID=fkLanguageBranchID,
			@IsMasterLang = CASE WHEN tblWorkPage.fkLanguageBranchID=tblPage.fkMasterLanguageBranchID THEN 1 ELSE 0 END,
			@IsMasterLangPendingPublish = tblPage.PendingPublish
	FROM tblWorkPage WITH (ROWLOCK XLOCK)
	INNER JOIN tblPage ON tblPage.pkID=tblWorkPage.fkPageID
	WHERE tblWorkPage.pkID=@WorkPageID
	
	IF (@@ROWCOUNT <> 1)
		RETURN 0

	IF @IsMasterLang=0 AND @IsMasterLangPendingPublish=1
		RAISERROR (N'editPublishPageVersion: Cannot publish a language before the master language has been published (WorkID=%d)', 16, 1, @WorkPageID)
		
	IF @PublishedDate IS NULL
		SET @PublishedDate = GetDate()
		
	BEGIN TRAN
			
	/* Move page information from worktable to published table */
	IF @IsMasterLang=1
	BEGIN
		UPDATE 
			tblPage
		SET
			ArchivePageGUID	= W.ArchivePageGUID,
			VisibleInMenu	= W.VisibleInMenu,
			ChildOrderRule	= W.ChildOrderRule,
			PeerOrder		= W.PeerOrder,
			PendingPublish  = 0,
			@FirstPublish  = tblPage.PendingPublish
		FROM 
			tblWorkPage AS W
		WHERE 
			tblPage.pkID=W.fkPageID AND 
			W.pkID=@WorkPageID
	END
	
	UPDATE 
			tblPageLanguage WITH (ROWLOCK XLOCK)
		SET
			ChangedByName = W.ChangedByName,
			PageLinkGUID	= W.PageLinkGUID,
			fkFrameID		= W.fkFrameID,
			Name			= W.Name,
			URLSegment		= W.URLSegment,
			LinkURL			= W.LinkURL,
			ExternalURL		= Lower(W.ExternalURL),
			AutomaticLink	= CASE WHEN W.LinkType = 2 OR W.LinkType = 3 THEN 0 ELSE 1 END,
			FetchData		= CASE WHEN W.LinkType = 4 THEN 1 ELSE 0 END,
			Created			= W.Created,
			Changed			= CASE WHEN W.ChangedOnPublish=0 AND tblPageLanguage.PendingPublish=0 THEN Changed ELSE @PublishedDate END,
			Saved			= @PublishedDate,
			@StartPublish = StartPublish	= COALESCE(W.StartPublish, tblPageLanguage.StartPublish, DATEADD(s, -30, @PublishedDate)),
			StopPublish		= W.StopPublish,
			PendingPublish  = 0,
			PublishedVersion= @WorkPageID,
			@FirstPublish  = tblPageLanguage.PendingPublish
		FROM 
			tblWorkPage AS W
		WHERE 
			tblPageLanguage.fkPageID=W.fkPageID AND
			W.fkLanguageBranchID=tblPageLanguage.fkLanguageBranchID AND
			W.pkID=@WorkPageID

	IF @@ROWCOUNT!=1
		RAISERROR (N'editPublishPageVersion: Cannot find correct version in tblPageLanguage for version %d', 16, 1, @WorkPageID)

	/* Remember that this version has been published, and get the publish dates back into tblWorkPage */
	UPDATE
		tblWorkPage
	SET
		HasBeenPublished=1,
		ReadyToPublish=1,
		Rejected=0,
		DelayedPublish=0,
		StartPublish=@StartPublish,
		Saved=@PublishedDate,
		NewStatusByName=@UserName,
		fkMasterVersionID = NULL
	WHERE
		pkID=@WorkPageID
		
	/* Remove all properties defined for this page except dynamic properties */
	DELETE FROM 
		tblProperty
	FROM 
		tblProperty
	INNER JOIN
		tblPageDefinition ON fkPageDefinitionID=pkID
	WHERE 
		fkPageID=@PageID AND
		fkPageTypeID IS NOT NULL AND
		fkLanguageBranchID=@LangBranchID
		
	/* Move properties from worktable to published table */
	INSERT INTO tblProperty 
		(fkPageDefinitionID,
		fkPageID,
		fkLanguageBranchID,
		Boolean,
		Number,
		FloatNumber,
		PageType,
		PageLink,
		Date,
		String,
		LongString,
		LongStringLength,
        linkGuid)
	SELECT
		fkPageDefinitionID,
		@PageID,
		@LangBranchID,
		Boolean,
		Number,
		FloatNumber,
		PageType,
		PageLink,
		Date,
		String,
		LongString,
		/* LongString is utf-16 - Datalength gives bytes, i e div by 2 gives characters */
		/* Include length to handle delayed loading of LongString with threshold */
		COALESCE(DATALENGTH(LongString), 0) / 2,
        LinkGuid
	FROM
		tblWorkProperty
	WHERE
		fkWorkPageID=@WorkPageID
	
	/* Move categories to published tables */
	DELETE 	tblCategoryPage
	FROM tblCategoryPage
	LEFT JOIN tblPageDefinition ON tblPageDefinition.pkID=tblCategoryPage.CategoryType 
	WHERE 	tblCategoryPage.fkPageID=@PageID
			AND (NOT fkPageTypeID IS NULL OR CategoryType=0)
			AND (tblPageDefinition.LanguageSpecific=1 OR @IsMasterLang=1)--Only lang specific on non-master
			AND tblCategoryPage.fkLanguageBranchID=@LangBranchID
			
	INSERT INTO tblCategoryPage
		(fkPageID,
		fkCategoryID,
		CategoryType,
		fkLanguageBranchID)
	SELECT
		@PageID,
		fkCategoryID,
		CategoryType,
		@LangBranchID
	FROM
		tblWorkCategory
	WHERE
		fkWorkPageID=@WorkPageID
	
	
	/* Remove obsolete versions */
	EXEC editDeleteObsoletePageVersions @PageID=@PageID, @MaxVersions=@MaxVersions
		
	COMMIT TRAN
		
	RETURN 0
END

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Altering [dbo].[sp_DatabaseVersion]'
GO
ALTER PROCEDURE dbo.sp_DatabaseVersion
AS
	RETURN 6100

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding constraints to [dbo].[tblScheduledItem]'
GO
ALTER TABLE [dbo].[tblScheduledItem] ADD CONSTRAINT [DF__tblScheduledItem__IsRunnning] DEFAULT ((0)) FOR [IsRunning]
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblWorkPage]'
GO
ALTER TABLE [dbo].[tblWorkPage] ADD
CONSTRAINT [FK_tblWorkPage_tblPage] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID]),
CONSTRAINT [FK_tblWorkPage_tblWorkPage2] FOREIGN KEY ([fkMasterVersionID]) REFERENCES [dbo].[tblWorkPage] ([pkID]),
CONSTRAINT [FK_tblWorkPage_tblFrame] FOREIGN KEY ([fkFrameID]) REFERENCES [dbo].[tblFrame] ([pkID]),
CONSTRAINT [FK_tblWorkPage_tblLanguageBranch] FOREIGN KEY ([fkLanguageBranchID]) REFERENCES [dbo].[tblLanguageBranch] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblCategoryPage]'
GO
ALTER TABLE [dbo].[tblCategoryPage] ADD
CONSTRAINT [FK_tblCategoryPage_tblPage] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblPageLanguageSetting]'
GO
ALTER TABLE [dbo].[tblPageLanguageSetting] ADD
CONSTRAINT [FK_tblPageLanguageSetting_tblPage] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblWorkCategory]'
GO
ALTER TABLE [dbo].[tblWorkCategory] ADD
CONSTRAINT [FK_tblWorkCategory_tblWorkPage] FOREIGN KEY ([fkWorkPageID]) REFERENCES [dbo].[tblWorkPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblProperty]'
GO
ALTER TABLE [dbo].[tblProperty] ADD
CONSTRAINT [FK_tblProperty_tblPage] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID]),
CONSTRAINT [FK_tblProperty_tblPage2] FOREIGN KEY ([PageLink]) REFERENCES [dbo].[tblPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblAccess]'
GO
ALTER TABLE [dbo].[tblAccess] ADD
CONSTRAINT [FK_tblAccess_tblPage] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblPage]'
GO
ALTER TABLE [dbo].[tblPage] ADD
CONSTRAINT [FK_tblPage_tblPage] FOREIGN KEY ([fkParentID]) REFERENCES [dbo].[tblPage] ([pkID]),
CONSTRAINT [FK_tblPage_tblPageType] FOREIGN KEY ([fkPageTypeID]) REFERENCES [dbo].[tblPageType] ([pkID]),
CONSTRAINT [FK_tblPage_tblLanguageBranch] FOREIGN KEY ([fkMasterLanguageBranchID]) REFERENCES [dbo].[tblLanguageBranch] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblWorkProperty]'
GO
ALTER TABLE [dbo].[tblWorkProperty] ADD
CONSTRAINT [FK_tblWorkProperty_tblPage] FOREIGN KEY ([PageLink]) REFERENCES [dbo].[tblPage] ([pkID]),
CONSTRAINT [FK_tblWorkProperty_tblWorkPage] FOREIGN KEY ([fkWorkPageID]) REFERENCES [dbo].[tblWorkPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblPageLanguage]'
GO
ALTER TABLE [dbo].[tblPageLanguage] ADD
CONSTRAINT [FK_tblPageLanguage_tblPage2] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID]),
CONSTRAINT [FK_tblPageLanguage_tblLanguageBranch] FOREIGN KEY ([fkLanguageBranchID]) REFERENCES [dbo].[tblLanguageBranch] ([pkID]),
CONSTRAINT [FK_tblPageLanguage_tblFrame] FOREIGN KEY ([fkFrameID]) REFERENCES [dbo].[tblFrame] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Adding foreign keys to [dbo].[tblPageSoftlink]'
GO
ALTER TABLE [dbo].[tblPageSoftlink] ADD
CONSTRAINT [FK_tblPageSoftlink_tblPage] FOREIGN KEY ([fkPageID]) REFERENCES [dbo].[tblPage] ([pkID])
GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO
PRINT N'Updating Active bit in table [dbo].[tblPageLanguageSetting]...';
GO

UPDATE tblPageLanguageSetting SET Active=1 WHERE fkReplacementBranchID IS NULL
UPDATE tblPageLanguageSetting SET Active=0 WHERE fkReplacementBranchID IS NOT NULL

GO
IF @@ERROR<>0 AND @@TRANCOUNT>0 ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT=0 BEGIN INSERT INTO #tmpErrors (Error) SELECT 1 BEGIN TRANSACTION END
GO

IF EXISTS (SELECT * FROM #tmpErrors) ROLLBACK TRANSACTION
GO
IF @@TRANCOUNT>0 BEGIN
PRINT 'The database update succeeded'
COMMIT TRANSACTION
END
ELSE PRINT 'The database update failed'
GO
DROP TABLE #tmpErrors
GO